/*-------------------------------------------
  desktop.c
    Customize Desktop Icon View
    Two_toNe 2002
---------------------------------------------*/
#include "tcdll.h"

#ifndef LVS_SMALLICON
#define LVS_SMALLICON           0x0002
#endif

static HWND hwndDesktop = NULL;
static LONG oldstyle = 0;


/*--------------------------------------------------
   initialize
----------------------------------------------------*/
void SetDesktopIcons(void)
{
	BOOL b;
	HWND hwnd;

	b = GetMyRegLong(NULL, "DesktopIconList", FALSE);
	if(!b)
	{
		EndDesktopIcons();
		return;
	}

	if (!hwndDesktop)
	{
		hwnd = FindWindow("Progman", "Program Manager");
		hwnd = FindWindowEx(hwnd, NULL, "SHELLDLL_DefView", NULL);
		hwnd = FindWindowEx(hwnd, NULL, "SysListView32", NULL);
		if(!hwnd) return;
		hwndDesktop = hwnd;
		oldstyle = GetWindowLong(hwndDesktop, GWL_STYLE);
		SetWindowLong(hwndDesktop, GWL_STYLE, oldstyle|LVS_SMALLICON);
	}

	if (!(GetWindowLong(hwndDesktop, GWL_STYLE)&LVS_SMALLICON))
	{
		oldstyle = GetWindowLong(hwndDesktop, GWL_STYLE);
		SetWindowLong(hwndDesktop, GWL_STYLE, oldstyle|LVS_SMALLICON);
	}
}

/*--------------------------------------------------
    reset desktop icons
----------------------------------------------------*/
void EndDesktopIcons(void)
{
	if(hwndDesktop)
	{
		SetWindowLong(hwndDesktop, GWL_STYLE, oldstyle);
	}
	hwndDesktop = NULL;
}
