/*-------------------------------------------
  startbtn.c
    customize start button
    Kazubon 1997-1999
---------------------------------------------*/

#include "tcdll.h"

#ifndef CCM_FIRST
#define CCM_FIRST               0x2000
#endif
#ifndef CCM_SETCOLORSCHEME
#define CCM_SETCOLORSCHEME      (CCM_FIRST + 2)
#endif

extern HANDLE hmod;
extern BOOL bVisualStyle;

/*------------------------------------------------
  globals
--------------------------------------------------*/
LRESULT CALLBACK WndProcStart(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK WndProcTask(HWND, UINT, WPARAM, LPARAM);
HWND hwndStart = NULL;
BOOL bStartMenuClock = FALSE;
BOOL bUseAlphaBlend = FALSE;
HBITMAP hbmpStartButton = NULL;

static WNDPROC oldWndProcStart = NULL, oldWndProcTask = NULL;
static HWND hwndTask = NULL, hwndTray = NULL;
static HBITMAP hbmpstart = NULL, hbmpstartold = NULL;
static int wStart = -1, hStart = -1;
static BOOL bCustStartButton = FALSE;
static BOOL bHideStartButton = FALSE;
static BOOL bStartButtonFlat = FALSE;
static BOOL bNormalStartButton = FALSE;
static BOOL bCursorOnStartButton = FALSE;
static BOOL bHiddenGrippers = FALSE;
static BOOL bIsRebar = FALSE;
static LONG oldClassStyleStartButton = 0;
static COLORREF CoolStartColorHigh, CoolStartColorLow, CoolStartColorFace,
			CoolStartColorHigh2, CoolStartColorLow2;

static char StartCaption[80];
static BOOL bStartTextDisable = FALSE;
static char StartFontName[80];

static void OnPaint(HWND hwnd, HDC hdc);
static void OnPaintXP(HWND hwnd, HDC hdc);
static void OnPaint9x(HWND hwnd, HDC hdc);
static void SetStartButtonBmp(void);
static void SetStartButtonBmpXP(void);
static void SetStartButtonBmp9x(void);
static void SetTaskWinPos(void);
static void SetRebarGrippers(void);

/*--------------------------------------------------
   initialize
----------------------------------------------------*/

BOOL GetVisualStyleInfo(wchar_t *dllname, wchar_t *sizename, wchar_t *colorname)
{
	int result;
	unsigned long length;
	HKEY hKey;
	wchar_t dllnametempW[MAX_PATH];

	//WXgL[̃I[v
	result = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\ThemeManager", 0, KEY_READ, &hKey);
	if(result != ERROR_SUCCESS)
		return FALSE;

	//VisualStyle DLLQbg
	length = _MAX_PATH;
	result = RegQueryValueExW(hKey,L"DllName", NULL, NULL, (BYTE*)dllname, &length);
	if(result != ERROR_SUCCESS)
		return FALSE;

	//%SystemRoot%u
	if(wcsstr(dllname,L"%SystemRoot%"))
	{
		wcscpy(dllnametempW, dllname);
		GetEnvironmentVariableW(L"SystemRoot", dllname, MAX_PATH);
		wcscat(dllname, dllnametempW + wcslen(L"%SystemRoot%"));
	}

	//TCYQbg
	length = 100;
	result = RegQueryValueExW(hKey,L"SizeName", NULL, NULL, (BYTE*)sizename, &length);
	if(result != ERROR_SUCCESS)
		return FALSE;

	//J[Qbg
	length = 100;
	result = RegQueryValueExW(hKey,L"ColorName", NULL, NULL, (BYTE*)colorname, &length);
	if(result != ERROR_SUCCESS)
		return FALSE;

	//WXgL[̃N[Y
	RegCloseKey(hKey);

	return TRUE;
}

int ReadResource(HMODULE hModule,wchar_t *name,wchar_t *type,wchar_t **buffer)
{
	HGLOBAL hGlobal;
	HRSRC hRsrc;
	void *ptr;
	int size;

	hRsrc = FindResourceW(hModule,name,type);
	hGlobal = LoadResource(hModule,hRsrc);
	ptr = LockResource(hGlobal);
	size = SizeofResource(hModule,hRsrc);

	*buffer = (wchar_t*)GlobalAlloc(GMEM_FIXED,size);
	CopyMemory(*buffer,ptr,size);

	return size;
}

#define GET_STARTBUTTONBITMAP 0
#define GET_STARTFONTNAME     1

BOOL LoadStartButtonBitmap(int gettype)
{
	HMODULE hStyle;
	int IniFileLength,i;
	int CurrentColor,CurrentSize,nColor,nSize;
	wchar_t SizeNameW[100],ColorNameW[100],DllNameW[MAX_PATH];
	wchar_t *ColorNames,*SizeNames,*FileResNames,*IniFileW;
	wchar_t ImageFileNameW[MAX_PATH];
	wchar_t *ptr,tmpname[MAX_PATH],tmppath[MAX_PATH];
	wchar_t StartFontNameW[MAX_PATH];
	HANDLE hTmp;
	DWORD written;

	//WXgVisualStylȅQbg
	if(GetVisualStyleInfo(DllNameW, SizeNameW, ColorNameW) == FALSE)
		return FALSE;

	//DLL[h
	hStyle = LoadLibraryW(DllNameW);

	ReadResource(hStyle,L"#1",L"COLORNAMES",&ColorNames);
	ReadResource(hStyle,L"#1",L"SIZENAMES",&SizeNames);
	ReadResource(hStyle,L"#1",L"FILERESNAMES",&FileResNames);

	//FJEg
	for(nColor = 0,CurrentColor = 0; *ColorNames; nColor++)
	{
		if(wcsstr(ColorNames,ColorNameW))
			CurrentColor = nColor;

		ColorNames += wcslen(ColorNames) + 1;
	}

	//TCYJEg
	for(nSize = 0,CurrentSize = 0; *SizeNames; nSize++)
	{
		if(wcsstr(SizeNames,SizeNameW))
			CurrentSize = nSize;

		SizeNames += wcslen(SizeNames) + 1;
	}

	//INIt@C
	for(i = 0;i < nSize * CurrentColor + CurrentSize;i++)
		FileResNames += wcslen(FileResNames) + 1;

	//INIt@Cǂݍ
	IniFileLength = ReadResource(hStyle,FileResNames,L"TEXTFILE",&IniFileW);

	//e|t@CINIt@Co
	GetTempPathW(MAX_PATH,tmppath);
	GetTempFileNameW(tmppath,L"vsc",0,tmpname);

	hTmp = CreateFileW(tmpname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL, NULL);
	WriteFile(hTmp,IniFileW,IniFileLength,&written,0);
	CloseHandle(hTmp);

	switch(gettype)
	{
	case GET_STARTBUTTONBITMAP:
		//X^[g{^ImageFileǂݏo
		GetPrivateProfileStringW(L"Start::Button",L"ImageFile",L"",ImageFileNameW,_MAX_PATH,tmpname);
		//ImageFile𐮌`B"\"".""_"ɒu
		for(ptr = wcspbrk(ImageFileNameW,L"\\.");ptr;ptr = wcspbrk(ImageFileNameW,L"\\."))
			*ptr = L'_';
		hbmpStartButton = LoadBitmapW(hStyle,ImageFileNameW);
		break;

	case GET_STARTFONTNAME:
		//X^[g{^Fontǂݏo
		GetPrivateProfileStringW(L"Start::Button",L"Font",L"",StartFontNameW,_MAX_PATH,tmpname);
		wcstombs(StartFontName, StartFontNameW, sizeof(StartFontName));
//		MessageBox(NULL, StartFontName, "start font", MB_OK);
		break;
	}

	//e|t@C폜
	DeleteFileW(tmpname);

	//svȃ
	GlobalFree(ColorNames);
	GlobalFree(SizeNames);
	GlobalFree(FileResNames);
	GlobalFree(IniFileW);

	FreeLibrary(hStyle);

	return TRUE;
}

void SetStartButton(HWND hwndClock)
{
	HWND hwnd;
	char classname[80];
	
	EndStartButton();
	
	bStartMenuClock = FALSE;
	if(GetMyRegLong(NULL, "StartButtonHide", FALSE))
		bStartMenuClock = GetMyRegLong(NULL, "StartMenuClock", FALSE);
	
	// "button""MSTaskSwWClass"̃EBhEnh𓾂
	hwndStart = hwndTask = NULL;
	hwndTray = GetParent(hwndClock); // TrayNotifyWnd
	if(hwndTray == NULL)
		return;
	hwnd = GetParent(hwndTray);      // Shell_TrayWnd
	if(hwnd == NULL)
		return;
	
	hwnd = GetWindow(hwnd, GW_CHILD);
	while(hwnd)
	{
		GetClassName(hwnd, classname, 80);
		if(lstrcmpi(classname, "Button") == 0)
			hwndStart = hwnd;
		else if(lstrcmpi(classname, "MSTaskSwWClass") == 0)
		{
			hwndTask = hwnd;
			bIsRebar = FALSE;
		}
		else if(lstrcmpi(classname, "ReBarWindow32") == 0)
		{
			hwndTask = hwnd;
			bIsRebar = TRUE;
		}
		hwnd = GetWindow(hwnd, GW_HWNDNEXT);
	}
	if(hwndStart == NULL || hwndTask == NULL)
	{
		hwndStart = hwndTask = NULL; return;
	}
	
	oldClassStyleStartButton = GetClassLong(hwndStart, GCL_STYLE);
	
	bCustStartButton = GetMyRegLong(NULL, "StartButton", FALSE);
	bHideStartButton = GetMyRegLong(NULL, "StartButtonHide", FALSE);
	bHiddenGrippers  = GetMyRegLong(NULL, "RebarGripperHide", FALSE);
	bStartButtonFlat = (bWinXP && bVisualStyle) ? TRUE : GetMyRegLong(NULL, "StartButtonFlat", FALSE);
	
	if(bIsRebar&&bHiddenGrippers)
		SetRebarGrippers();
	
	if(!bCustStartButton && !bHideStartButton && !bStartButtonFlat) return;
	
	if(bCustStartButton || bStartButtonFlat)
	{
		if (bStartButtonFlat)
		{
			CoolStartColorHigh = GetSysColor(COLOR_3DHILIGHT);
			CoolStartColorHigh2 = GetSysColor(COLOR_3DFACE);
			CoolStartColorLow = GetSysColor(COLOR_3DSHADOW);
			CoolStartColorLow2 = GetSysColor(COLOR_3DFACE);
			CoolStartColorFace = GetSysColor(COLOR_3DFACE);
		}
		else
		{
			bNormalStartButton = TRUE;
			CoolStartColorHigh = GetSysColor(COLOR_3DHILIGHT);
			CoolStartColorHigh2 = GetSysColor(COLOR_3DLIGHT);
			CoolStartColorLow = GetSysColor(COLOR_3DDKSHADOW);
			CoolStartColorLow2 = GetSysColor(COLOR_3DSHADOW);
			CoolStartColorFace = GetSysColor(COLOR_3DFACE);
		}

		SetClassLong(hwndStart, GCL_STYLE,
			oldClassStyleStartButton & ~(CS_HREDRAW|CS_VREDRAW));
	}
	
	// TuNX
	oldWndProcStart = (WNDPROC)GetWindowLong(hwndStart, GWL_WNDPROC);
	SetWindowLong(hwndStart, GWL_WNDPROC, (LONG)WndProcStart);
	oldWndProcTask = (WNDPROC)GetWindowLong(hwndTask, GWL_WNDPROC);
	SetWindowLong(hwndTask, GWL_WNDPROC, (LONG)WndProcTask);
	
	if(bHideStartButton) // {^B
	{
		RECT rc; POINT pt;
		ShowWindow(hwndStart, SW_HIDE);
		wStart = 0; hStart = 0;
		GetWindowRect(hwndTray, &rc);
		pt.x = rc.left; pt.y = rc.top;
		ScreenToClient(GetParent(hwndTray), &pt);
		SetWindowPos(hwndStart, NULL, pt.x, pt.y,
			rc.right - rc.left, rc.bottom - rc.top,
			SWP_NOZORDER|SWP_NOACTIVATE);
	}
	else if(bCustStartButton)
	{
		// {^prbg}bv̐ݒ
		SetStartButtonBmp();
	}
	// MSTaskSwWClass̈ʒuETCY̐ݒ
	if(bCustStartButton || bHideStartButton)
		SetTaskWinPos();
}

/*--------------------------------------------------
    reset start button
----------------------------------------------------*/
void EndStartButton(void)
{
	if(bHiddenGrippers && hwndTask && IsWindow(hwndTask))
	{
		COLORSCHEME colScheme2;
		
		colScheme2.dwSize = sizeof(colScheme2);
		colScheme2.clrBtnHighlight = GetSysColor(COLOR_3DHILIGHT);
		colScheme2.clrBtnShadow = GetSysColor(COLOR_3DSHADOW);
		
		SendMessage(hwndTask, RB_SETCOLORSCHEME, 0, (LPARAM) (LPCOLORSCHEME)&colScheme2);
		InvalidateRect(hwndTask, NULL, TRUE);
	}
	
	if(hwndStart && IsWindow(hwndStart))
	{
		if(hbmpstartold != NULL)
		{
			SendMessage(hwndStart, BM_SETIMAGE,
				0, (LPARAM)hbmpstartold);
			hbmpstartold = NULL;
		}
		SetClassLong(hwndStart, GCL_STYLE, oldClassStyleStartButton);

#if ENABLE_CHECK_SUBCLASS_NESTING
		if(oldWndProcStart && (WNDPROC)WndProcStart == (WNDPROC)GetWindowLong(hwndStart, GWL_WNDPROC))
#else
		if(oldWndProcStart)
#endif
			SetWindowLong(hwndStart, GWL_WNDPROC, (LONG)oldWndProcStart);
		bStartTextDisable = FALSE;
		SetWindowPos(hwndStart, NULL, 0, 0, 0, 0,
			SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
		ShowWindow(hwndStart, SW_SHOW);
	}
	oldWndProcStart = NULL; hwndStart = NULL;
	
	if(hbmpstart) DeleteObject(hbmpstart); hbmpstart = NULL;
	if(hbmpStartButton) DeleteObject(hbmpStartButton); hbmpStartButton = NULL;
	
	if(hwndTask && IsWindow(hwndTask))
	{
#if ENABLE_CHECK_SUBCLASS_NESTING
		if(oldWndProcTask && (WNDPROC)WndProcTask == (WNDPROC)GetWindowLong(hwndTask, GWL_WNDPROC))
#else
		if(oldWndProcTask)
#endif
			SetWindowLong(hwndTask, GWL_WNDPROC, (LONG)oldWndProcTask);
	}
	oldWndProcTask = NULL; hwndTask = NULL;
	
	bCustStartButton = bHideStartButton = bStartButtonFlat = FALSE;
	bNormalStartButton = FALSE; bHiddenGrippers = FALSE;
}

/*------------------------------------------------
   subclass procedure of start button
--------------------------------------------------*/
LRESULT CALLBACK WndProcStart(HWND hwnd, UINT message,
	WPARAM wParam, LPARAM lParam)
{
//	if(!bCustStartButton && bWinXP && bVisualStyle)
//		return CallWindowProc(oldWndProcStart, hwnd, message, wParam, lParam);

	switch(message)
	{
		case WM_SYSCOLORCHANGE:  // VXe̐ݒύX
		case WM_WININICHANGE:
			if(bCustStartButton && !bHideStartButton)
				PostMessage(hwnd, WM_USER+10, 0, 0L);
			return 0;
		case (WM_USER + 10):     // ď
			SetStartButtonBmp();
			return 0;
		case WM_WINDOWPOSCHANGING:  // TCYύXȂ
		{
			LPWINDOWPOS pwp;
			if(!(bCustStartButton || bHideStartButton)) break;
			pwp = (LPWINDOWPOS)lParam;
			if(!(pwp->flags & SWP_NOSIZE))
			{
				if(wStart > 0) pwp->cx = wStart;
				if(hStart > 0) pwp->cy = hStart;
			}
			if(bHideStartButton)
			{
				RECT rc; POINT pt;
				GetWindowRect(hwndTray, &rc);
				pt.x = rc.left; pt.y = rc.top;
				ScreenToClient(GetParent(hwndTray), &pt);
				pwp->x = pt.x; pwp->y = pt.y;
				pwp->cx = rc.right - rc.left;
				pwp->cy = rc.bottom - rc.top;
			}
			break;
		}
		case WM_DESTROY:
			if(hbmpstartold)
				SendMessage(hwndStart, BM_SETIMAGE, 0, (LPARAM)hbmpstartold); hbmpstartold = NULL;
			if(hbmpstart)
				DeleteObject(hbmpstart); hbmpstart = NULL;
			if(hbmpStartButton)
				DeleteObject(hbmpStartButton); hbmpStartButton = NULL;
			break;

		// -------- for "flat start button" -----------
		case WM_SETTEXT:
			if(bStartTextDisable == TRUE)
				return 0;
		case WM_PAINT:
		{
			HDC hdc;
			PAINTSTRUCT ps;
			if(!bCustStartButton && !bStartButtonFlat) break;
			if(bWinXP && bVisualStyle && !hbmpstart) break;
			hdc = BeginPaint(hwnd, &ps);
			OnPaint(hwnd, hdc);
			EndPaint(hwnd, &ps);
			return 0;
		}
		case BM_SETSTATE:
		{
			LRESULT r;
			HDC hdc;
			if(!bCustStartButton && !bStartButtonFlat) break;
			if(bWinXP && bVisualStyle && !hbmpstart) break;
			r = CallWindowProc(oldWndProcStart, hwnd, message, wParam, lParam);
			hdc = GetDC(hwnd);
			OnPaint(hwnd, hdc);
			ReleaseDC(hwnd, hdc);
			return 0;
		}
		case WM_SETFOCUS:
			if (bCustStartButton || !bStartButtonFlat) break;
			return 0;
		case WM_MOUSELEAVE:
		case WM_MOUSEMOVE:
			if(!bCustStartButton) break;
			CheckCursorOnStartButton();
			break;
	}
	return CallWindowProc(oldWndProcStart, hwnd, message, wParam, lParam);
}

/*--------------------------------------------------
   subclass procedure of
   "MSTaskSwWClass"/"ReBarWindow32" class window
----------------------------------------------------*/
LRESULT CALLBACK WndProcTask(HWND hwnd, UINT message,
	WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_WINDOWPOSCHANGING: // ʒuETCY̐
		{
			LPWINDOWPOS pwp;
			RECT rcBar, rcTray;
			
			if(!(bCustStartButton || bHideStartButton)) break;
			
			pwp = (LPWINDOWPOS)lParam;
//			if((pwp->flags & SWP_NOMOVE) ||
//				wStart < 0 || hStart < 0) break;
			
			GetClientRect(GetParent(hwndStart), &rcBar); // ^XNo[
			GetWindowRect(hwndTray, &rcTray); // TrayNotifyWnd
			
			// ^XNo[ûƂ
			if(rcBar.right > rcBar.bottom)
			{
				pwp->x = 2 + wStart; // Eʒu
				pwp->cx = rcTray.left - 2 - wStart - 2; // 
				if(wStart > 0)
				{
					pwp->x += 2; pwp->cx -= 2;
				}
			}
			else // cûƂ
			{
				if(rcTray.top < pwp->y)
				{
					pwp->cy = rcBar.bottom - 2 - hStart - 2; // 
				}
				else
				{
					pwp->cy = rcTray.top - 2 - hStart - 2; // 
				}
				pwp->y = 2 + hStart; // ʒu
				if(hStart > 0)
				{
					pwp->y += 1; pwp->cy -= 2;
				}
			}
			break;
		}
	}
	return CallWindowProc(oldWndProcTask, hwnd, message, wParam, lParam);
}

/*--------------------------------------------------
@X^[g{^̃rbg}bvƃTCY̐ݒ
----------------------------------------------------*/
void SetStartButtonBmp(void)
{
	if (bWinXP && bVisualStyle)
		SetStartButtonBmpXP();
	else
		SetStartButtonBmp9x();
}

void SetStartButtonBmpXP(void)
{
	char filepath[MAX_PATH];
	BITMAP bmp;
	BITMAPINFO bi;
	RECT rc;
	HFILE hf;
	
	if(hbmpstart) DeleteObject(hbmpstart);
	hbmpstart = NULL;
	if(hbmpStartButton) DeleteObject(hbmpStartButton);
	hbmpStartButton = NULL;

	// t@CACRprbg}bv̓ǂݍ
	if(!GetMyRegStr(NULL, "StartButtonIcon",filepath,MAX_PATH, ""))
	{
		HDC hdc;
		HFONT hfont;
		LOGFONT logfont;
		NONCLIENTMETRICS ncm;
		SIZE sz;
		char *p;
		int point;

		GetMyRegStr(NULL, "StartButtonCaption", StartCaption, 80, "");
		bStartTextDisable = FALSE;
		SendMessage(hwndStart, WM_SETTEXT, 0, (LPARAM)StartCaption);
		SetWindowPos(hwndStart, NULL, 0, 0, 0, 0,
			SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE|SWP_SHOWWINDOW);
		bStartTextDisable = TRUE;

		GetClientRect(hwndStart,&rc);
		hStart = rc.bottom - rc.top;

		StartFontName[0] = 0;
		if(LoadStartButtonBitmap(GET_STARTFONTNAME) == TRUE)
		{
			//visual style
			p = strchr(StartFontName, ',');
			*p = 0;
			point = atoi(p+1);
			if(point == 0) point = 9;

			hdc = GetDC(hwndStart);
			memset(&logfont, 0, sizeof(LOGFONT));
			logfont.lfHeight = -MulDiv(point, GetDeviceCaps(hdc, LOGPIXELSY), 72);
			logfont.lfWeight = 400;
//			logfont.lfCharSet = DEFAULT_CHARSET;		//2oCg̒Ȃ
			logfont.lfCharSet = SHIFTJIS_CHARSET;
//			strcpy(logfont.lfFaceName, "Franklin Gothic Medium");
			strcpy(logfont.lfFaceName, StartFontName);

			hfont = CreateFontIndirect(&logfont);
			SelectObject(hdc, hfont);
			//LvV̕𓾂
			GetTextExtentPoint32(hdc, StartCaption, strlen(StartCaption), &sz);
			wStart = sz.cx + 64;			//64͍̖l
			ReleaseDC(hwndStart, hdc);
			DeleteObject(hfont);
		}
		else
		{
			//classic style
			hdc = GetDC(hwndStart);
			ncm.cbSize = sizeof(ncm);
			SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, &ncm, 0);
			ncm.lfCaptionFont.lfWeight = FW_BOLD;
			hfont =  CreateFontIndirect(&(ncm.lfCaptionFont));
			SelectObject(hdc, hfont);
			//LvV̕𓾂
			GetTextExtentPoint32(hdc, StartCaption, strlen(StartCaption), &sz);
			wStart = sz.cx + 30;
			ReleaseDC(hwndStart, hdc);
			DeleteObject(hfont);
		}

		return;
	}

	hbmpstart = (HBITMAP)LoadImage(0,filepath,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);

	if(!hbmpstart)
		return;

	//32bitrbg}bvȂAt@uhL
	hf = _lopen(filepath, OF_READ);
	_llseek(hf, sizeof(BITMAPFILEHEADER), 0);
	_lread(hf, &bi, sizeof(bi));
	_lclose(hf);

	bUseAlphaBlend = (bi.bmiHeader.biBitCount == 32);

	//{^̓̕rbg}bvɂ킹
	// łΏɓ\rbg}bv╶ɍ킹ĕωA
	//   ͂Ńrbg}bvLяk݂͖̂ʓ|
	//{^̍͌ێ
	GetClientRect(hwndStart,&rc);
	GetObject(hbmpstart,sizeof(BITMAP),&bmp);
	wStart = bmp.bmWidth;
	hStart = rc.bottom - rc.top;

	LoadStartButtonBitmap(GET_STARTBUTTONBITMAP);
}

void SetStartButtonBmp9x(void)
{
	char s[1024], caption[80];
	HBITMAP hbmpicon, hbmpold;
	HICON hicon;
	HDC hdc, hdcMem;
	HFONT hfont;
	BITMAP bmp;
	int whbmp, hhbmp, cxicon, cyicon;
	
	if(hwndStart == NULL) return;
	
	hbmpicon = NULL; hicon = NULL;
	cxicon = GetSystemMetrics(SM_CXSMICON);
	cyicon = GetSystemMetrics(SM_CYSMICON);
	
	// t@CACRprbg}bv̓ǂݍ
	if(GetMyRegStr(NULL, "StartButtonIcon", s, 1024, "") > 0)
	{
		char fname[MAX_PATH], head[2];
		HFILE hf;
		
		parse(fname, s, 0);
		hf = _lopen(fname, OF_READ);
		if(hf != HFILE_ERROR)
		{
			_lread(hf, head, 2);
			_lclose(hf);
			if(head[0] == 'B' && head[1] == 'M') //rbg}bv̏ꍇ
				hbmpicon = ReadBitmap(hwndStart, fname, TRUE);
			else if(head[0] == 'M' && head[1] == 'Z') //st@C̏ꍇ
			{
				char numstr[10], *p; int n;
				HICON hiconl;
				parse(numstr, s, 1);
				n = 0; p = numstr;
				while(*p)
				{
					if(*p < '0' || '9' < *p) break;
					n = n * 10 + *p++ - '0';
				}
				if(ExtractIconEx(fname, n, &hiconl, &hicon, 1) < 2)
					hicon = NULL;
				else DestroyIcon(hiconl);
			}
			else // ACȐꍇ
			{
				hicon = (HICON)LoadImage(hmod, fname,
					IMAGE_ICON, cxicon, cyicon,
					LR_DEFAULTCOLOR|LR_LOADFROMFILE);
			}
		}
	}
	
	if(hbmpicon)
	{
		GetObject(hbmpicon, sizeof(BITMAP), (LPVOID)&bmp);
		cxicon = bmp.bmWidth;
		cyicon = bmp.bmHeight;
	}

	// LvV̎擾
	GetMyRegStr(NULL, "StartButtonCaption", caption, 80, "");
	
	hdc = GetDC(hwndStart);
	
	// {^p̃tHg = ^Cgo[̃tHg + BOLD
	hfont = NULL;
	whbmp = cxicon; hhbmp = cyicon;
	if(caption[0])
	{
		NONCLIENTMETRICS ncm;
		SIZE sz;
		ncm.cbSize = sizeof(ncm);
		SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, &ncm, 0);
		ncm.lfCaptionFont.lfWeight = FW_BOLD;
		hfont =  CreateFontIndirect(&(ncm.lfCaptionFont));
		SelectObject(hdc, hfont);
		
		//LvV̕𓾂
		GetTextExtentPoint32(hdc, caption, strlen(caption), &sz);
		whbmp = sz.cx;
		if(hbmpicon || hicon) whbmp += cxicon + 2;
		hhbmp = sz.cy;
		if((hbmpicon || hicon) && cyicon > sz.cy)
			hhbmp = cyicon;
		//if(hhbmp < 16) hhbmp = 16;
	}
	
	// rbg}bv̍쐬
	hdcMem = CreateCompatibleDC(hdc);
	hbmpstart = CreateCompatibleBitmap(hdc, whbmp, hhbmp);
	SelectObject(hdcMem, hbmpstart);
	
	{ // wiFœhԂ
		RECT rc; HBRUSH hbr;
		SetRect(&rc, 0, 0, whbmp, hhbmp);
		hbr = CreateSolidBrush(CoolStartColorFace);
		FillRect(hdcMem, &rc, hbr);
		DeleteObject(hbr);
	}
	
	// rbg}bvɃACR̊G`
	if(hbmpicon)
	{
		HDC hdcicon;
		hdcicon = CreateCompatibleDC(hdc);
		SelectObject(hdcicon, hbmpicon);
		BitBlt(hdcMem, 0, (hhbmp - cyicon)/2,
			cxicon, cyicon, hdcicon, 0, 0, SRCCOPY);
		DeleteDC(hdcicon);
		DeleteObject(hbmpicon);
	}
	if(hicon)
	{
		DrawIconEx(hdcMem, 0, (hhbmp - cyicon)/2,
			hicon, cxicon, cyicon, 0, NULL, DI_NORMAL);
		DestroyIcon(hicon);
	}
	
	// rbg}bvɃLvV
	if(caption[0])
	{
		TEXTMETRIC tm;
		int x, y;

		GetTextMetrics(hdc, &tm);
		SelectObject(hdcMem, hfont);
		x = 0; if(hbmpicon || hicon) x = cxicon + 2;
		y = (hhbmp - tm.tmHeight) / 2;
		SetBkMode(hdcMem, TRANSPARENT);
		SetTextColor(hdcMem, GetSysColor(COLOR_BTNTEXT));
		TextOut(hdcMem, x, y, caption, strlen(caption));
	}
	
	DeleteDC(hdcMem);
	ReleaseDC(hwndStart, hdc);
	if(hfont) DeleteObject(hfont);

	// {^Ƀrbg}bvݒ
	hbmpold = (HBITMAP)SendMessage(hwndStart,
		BM_SETIMAGE, 0, (LPARAM)hbmpstart);

	// ȑÕrbg}bvۑ / j
	if(hbmpstartold == NULL) hbmpstartold = hbmpold;
	else DeleteObject(hbmpold);
	
	// {^̃TCY̐ݒ  F160x80
	wStart = whbmp + 8;
	if(wStart > 160) wStart = 160;
	hStart = GetSystemMetrics(SM_CYCAPTION) + 3;
	if(hhbmp + 6 > hStart) hStart = hhbmp + 6;
	if(hStart > 80) hStart = 80;
	SetWindowPos(hwndStart, NULL, 0, 0,
		wStart, hStart,
		SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE);
}

/*--------------------------------------------------
@MSTaskSwWClass̈ʒuETCY̐ݒ
----------------------------------------------------*/
void SetTaskWinPos(void)
{
	RECT rcBar, rcTask, rcTray;
	POINT pt;
	int x, y, w, h;

	GetClientRect(GetParent(hwndStart), &rcBar);  // Shell_TrayWnd
	GetWindowRect(hwndTray, &rcTray); // TrayNotifyWnd
	GetWindowRect(hwndTask, &rcTask);             // MSTaskSwWClass
	
	// MSTaskSwWClass̉Eʒu
	pt.x = rcTask.left; pt.y = rcTask.top;
	ScreenToClient(GetParent(hwndStart), &pt);
	
	x = pt.x; y = pt.y;
	w = rcTask.right - rcTask.left;
	h = rcTask.bottom - rcTask.top;
	
	// ^XNo[ûƂ
	if(rcBar.right > rcBar.bottom)
	{
		x = 2 + wStart;
		w = rcTray.left - 2 - wStart - 2;
		if(wStart > 0)
		{
			x += 2; w -= 2;
		}
	}
	else // cûƂ
	{
		y = 2 + hStart;
		h = rcTray.top - 2 - hStart - 2;
		if(hStart > 0)
		{
			y += 1; h -= 2;
		}
	}
	SetWindowPos(hwndTask, NULL, x, y, w, h,
		SWP_NOZORDER|SWP_NOACTIVATE);
}

/*--------------------------------------------------
   draw "flat start button"
----------------------------------------------------*/
void OnPaint(HWND hwnd, HDC hdc)
{
	if (bWinXP && bVisualStyle)
		OnPaintXP(hwnd, hdc);
	else
		OnPaint9x(hwnd, hdc);
}

void OnPaintXP(HWND hwnd, HDC hdc)
{
	HDC hdcStartButton,hdcImage,hdcTemp;
	HBITMAP hbmpTemp;
	BITMAP bmp;
	RECT rc;
	int wStartButton,hStartButton,wImage,hImage,topStartButton;
	BOOL bPushed;
	BLENDFUNCTION bf;
	
	bPushed = (SendMessage(hwnd, BM_GETSTATE, 0, 0) & BST_PUSHED)?1:0;
	GetClientRect(hwnd, &rc);
	
	//Start{^Bitmapݒ
	hdcStartButton = CreateCompatibleDC(hdc);
	SaveDC(hdcStartButton);
	SelectObject(hdcStartButton, hbmpStartButton);
	GetObject(hbmpStartButton, sizeof(BITMAP), (LPVOID)&bmp);
	wStartButton = bmp.bmWidth;
	hStartButton = bmp.bmHeight/3;

	//C[Wt@CpDC
	hdcImage = CreateCompatibleDC(hdc);
	SaveDC(hdcImage);
	SelectObject(hdcImage, hbmpstart);
	GetObject(hbmpstart, sizeof(BITMAP), (LPVOID)&bmp);
	wImage = bmp.bmWidth;
	hImage = bmp.bmHeight;
	
	//np
	hdcTemp = CreateCompatibleDC(hdc);
	SaveDC(hdcTemp);
	hbmpTemp = CreateCompatibleBitmap(hdc,wImage,rc.bottom);
	SelectObject(hdcTemp, hbmpTemp);
	MyDrawThemeParentBackground(hwnd,hdcTemp,0);
	
	if(bPushed)
		topStartButton = hStartButton * 2;
	else
	if(bCursorOnStartButton)
		topStartButton = hStartButton * 1;
	else
		topStartButton = hStartButton * 0;
		
	MyTransparentBlt(hdcTemp,0,0,wImage,rc.bottom,
					hdcStartButton,0,topStartButton,wStartButton,hStartButton,0x00ff00ff);

	if(bUseAlphaBlend){
		ZeroMemory(&bf,sizeof(bf));

		bf.AlphaFormat = AC_SRC_ALPHA;
		bf.BlendOp = AC_SRC_OVER;
		bf.SourceConstantAlpha = 0xff;
		
		MyAlphaBlend(hdcTemp,0,(rc.bottom - hImage)/2,wImage,hImage,
						hdcImage,0,0,wImage,hImage,bf);
	}else{
		MyTransparentBlt(hdcTemp,0,(rc.bottom - hImage)/2,wImage,hImage,
						hdcImage,0,0,wImage,hImage,0x00ff00ff);
	}

	BitBlt(hdc, 0, 0,wImage,rc.bottom, hdcTemp, 0, 0, SRCCOPY);

	RestoreDC(hdcTemp,-1);
	RestoreDC(hdcImage,-1);
	RestoreDC(hdcStartButton,-1);
	DeleteDC(hdcTemp);
	DeleteDC(hdcImage);
	DeleteDC(hdcStartButton);
	DeleteObject(hbmpTemp);
}

void OnPaint9x(HWND hwnd, HDC hdc)
{
	HDC hdcMem1, hdcMem2;
	HBITMAP hbmp, hbmpTemp;
	HBRUSH hbr;
	BITMAP bmp;
	RECT rc;
	int x, y, w, h;
	BOOL bPushed;
	
	bPushed = (SendMessage(hwnd, BM_GETSTATE, 0, 0) & BST_PUSHED)?1:0;
	
	hdcMem1 = CreateCompatibleDC(hdc);
	if(hbmpstart != NULL)
		hbmp = hbmpstart;
	else
		hbmp = (HBITMAP)SendMessage(hwnd, BM_GETIMAGE, IMAGE_BITMAP, 0);

	SelectObject(hdcMem1, hbmp);
	GetObject(hbmp, sizeof(BITMAP), (LPVOID)&bmp);
	w = bmp.bmWidth; h = bmp.bmHeight;
	
	hdcMem2 = CreateCompatibleDC(hdc);
	GetClientRect(hwnd, &rc);
	hbmpTemp = CreateCompatibleBitmap(hdc, rc.right, rc.bottom);
	SelectObject(hdcMem2, hbmpTemp);
	
	hbr = CreateSolidBrush(CoolStartColorFace);
	FillRect(hdcMem2, &rc, hbr);
	DeleteObject(hbr);
	
	x = (rc.right - w)/2 + (!bCustStartButton ? 2:0) + (int)bPushed;
	y = (rc.bottom - h)/2 + (int)bPushed;
	BitBlt(hdcMem2, x, y, w, h, hdcMem1, 0, 0, SRCCOPY);

	if(bPushed || bCursorOnStartButton || bNormalStartButton) // draw frame
	{
		HPEN hpen, hpenold;
		int color;
		
		color = (bPushed?CoolStartColorLow:CoolStartColorHigh);
		hpen = CreatePen(PS_SOLID, 1, color);
		hpenold = SelectObject(hdcMem2, hpen);
		MoveToEx(hdcMem2, 0, 0, NULL);
		LineTo(hdcMem2, rc.right, 0);
		MoveToEx(hdcMem2, 0, 0, NULL);
		LineTo(hdcMem2, 0, rc.bottom);
		SelectObject(hdcMem2, hpenold);
		DeleteObject(hpen);
		
		color = (bPushed?CoolStartColorHigh:CoolStartColorLow);
		hpen = CreatePen(PS_SOLID, 1, color);
		hpenold = SelectObject(hdcMem2, hpen);
		MoveToEx(hdcMem2, rc.right-1, 0, NULL);
		LineTo(hdcMem2, rc.right-1, rc.bottom);
		MoveToEx(hdcMem2, 0, rc.bottom-1, NULL);
		LineTo(hdcMem2, rc.right, rc.bottom-1);
		SelectObject(hdcMem2, hpenold);
		DeleteObject(hpen);

		color = (bPushed?CoolStartColorLow2:CoolStartColorHigh2);
		hpen = CreatePen(PS_SOLID, 1, color);
		hpenold = SelectObject(hdcMem2, hpen);
		MoveToEx(hdcMem2, 1, 1, NULL);
		LineTo(hdcMem2, rc.right - 1, 1);
		MoveToEx(hdcMem2, 1, 1, NULL);
		LineTo(hdcMem2, 1, rc.bottom - 1);
		SelectObject(hdcMem2, hpenold);
		DeleteObject(hpen);

		color = (bPushed?CoolStartColorHigh2:CoolStartColorLow2);
		hpen = CreatePen(PS_SOLID, 1, color);
		hpenold = SelectObject(hdcMem2, hpen);
		MoveToEx(hdcMem2, rc.right-2, 1, NULL);
		LineTo(hdcMem2, rc.right-2, rc.bottom-1);
		MoveToEx(hdcMem2, 1, rc.bottom-2, NULL);
		LineTo(hdcMem2, rc.right-1, rc.bottom-2);
		SelectObject(hdcMem2, hpenold);
		DeleteObject(hpen);
	}
	
	BitBlt(hdc, 0, 0,
		rc.right, rc.bottom, hdcMem2, 0, 0, SRCCOPY);
	
	DeleteDC(hdcMem1);
	DeleteDC(hdcMem2);
	DeleteObject(hbmpTemp);
}

/*--------------------------------------------------
   called when clock window receive WM_TIMER.
   check cursor position, and draw "flat start button"
----------------------------------------------------*/
void CheckCursorOnStartButton(void)
{
	POINT pt;
	RECT rc;
	
	if(hwndStart == NULL) return;
	if(!bStartButtonFlat) return;
	
	GetCursorPos(&pt);
	GetWindowRect(hwndStart, &rc);
	if(PtInRect(&rc, pt))
	{
		if(!bCursorOnStartButton)
		{
			bCursorOnStartButton = TRUE;
			InvalidateRect(hwndStart, NULL, FALSE);
		}
	}
	else
	{
		if(bCursorOnStartButton)
		{
			bCursorOnStartButton = FALSE;
			InvalidateRect(hwndStart, NULL, FALSE);
		}
	}
}

void SetRebarGrippers(void)
{
	COLORSCHEME colScheme;

	if(!bHiddenGrippers) return;

	colScheme.dwSize = sizeof(colScheme);
	colScheme.clrBtnHighlight = GetSysColor(COLOR_3DFACE);
	colScheme.clrBtnShadow = GetSysColor(COLOR_3DFACE);

	SendMessage(hwndTask, RB_SETCOLORSCHEME, 0, (LPARAM) (LPCOLORSCHEME)&colScheme);
	InvalidateRect(hwndTask, NULL, TRUE);
}
