/*-----------------------------------------------------
  tclock.c
  customize the tray clock
  KAZUBON 1997-2001
-------------------------------------------------------*/
#include "tcdll.h"

#define GRADIENT_FILL_RECT_H    0x00000000
#define GRADIENT_FILL_RECT_V    0x00000001

#ifndef TTS_NOANIMATE
#define TTS_NOANIMATE 0x10
#endif
#ifndef TTS_NOFADE
#define TTS_NOFADE 0x20
#endif
#ifndef TTS_BALLOON
#define TTS_BALLOON 0x40
#endif
#ifndef TTM_SETTITLE
#define TTM_SETTITLE 0x420
#endif
#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED 0x80000
#endif
#ifndef WS_EX_COMPOSITED
#define WS_EX_COMPOSITED 0x02000000L
#endif

//c[`bv̋e
#define LEN_TOOLTIP   10240

//Ot̋L^
#define MAXGRAPHLOG 600

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
void InitClock(HWND hwnd);
void EndClock(void);
BOOL IsIE4(HWND hwnd);
void CreateTip(HWND hwnd);
void CreateClockDC(HWND hwnd);
void ReadData(HWND hwnd);
void InitSysInfo(HWND hwnd);
void OnTimer(HWND hwnd);
void OnTimerUpperTaskbar(HWND hwnd);
void OnTimerTooltip(HWND hwnd);
void DrawClockSub(HWND hwnd, HDC hdc, SYSTEMTIME* pt, int beat100);
void DrawGraph(HWND hwnd, HDC hdc, int xclock, int yclock, int wclock, int hclock);
LRESULT OnCalcRect(HWND hwnd);
void OnCopy(HWND hwnd, LPARAM lParam);
void UpdateSysRes(HWND hwnd, BOOL bsysres, BOOL bbattery, BOOL bmem, BOOL bmb, BOOL bpermon, BOOL bnet, BOOL bhdd, BOOL bcpuc, BOOL bvol);
void InitDaylightTimeTransition(void);
BOOL CheckDaylightTimeTransition(SYSTEMTIME *lt);
static BOOL GetToolTipText(PSTR pszText);
void FitClock(); //390
void getGraphVal();
void OnCopyData(HWND hwnd, COPYDATASTRUCT* pCopyDataStruct);

static void UpdateTooltipTitle(void);
static void UpdateTooltipText(void);
static void OnTimerTooltip(HWND hwnd);

/*------------------------------------------------
  shared data among processes
--------------------------------------------------*/
#ifdef _MSC_VER
#pragma data_seg("MYDATA")
HHOOK hhook = 0;
HWND hwndTClockMain = NULL;
HWND hwndTaskbar = NULL;
HWND hwndHook = NULL;
BOOL bHookEnable = FALSE;
char szShareBuf[81] = { 0 };
#pragma data_seg()
#else
extern HWND hwndTClockMain;
extern HWND hwndTaskbar;
#endif

/*------------------------------------------------
  globals
--------------------------------------------------*/
HANDLE hmod = 0;
HWND hwndClock = NULL;
WNDPROC oldWndProc = NULL;
BOOL bTimer = FALSE;
BOOL bTimerTesting = FALSE;
HDC hdcClock = NULL;
static HGDIOBJ hbmpClockOld = NULL;
HBITMAP hbmpClock = NULL;
HBITMAP hbmpClockSkin = NULL;
HFONT hFon = NULL;
DWORD balloonFlg = 0;
int alphaTip = 255;
int tipDispTime = 5;
int tipIcon = 0;	//end
HWND hwndTip = NULL;
COLORREF colback, colback2, colfore, tipFonCol, tipBakCol;
BOOL fillbackcolor = FALSE;
DWORD grad;

static BOOL bGraphTimerStart = FALSE;
static BOOL bTooltipTimerStart = FALSE;
static int iTipDispInterval = 1;
static int iTipSelected = 0;
static BOOL bTipCustomDrawDisable = FALSE;
static BOOL bTipUpdateEnable[3] = {FALSE, FALSE, FALSE};
static BOOL bTooltipUpdated = FALSE;
static BOOL bTooltipShow = FALSE;
static BOOL bTooltipBalloon = FALSE;
static BOOL bToolTipHasTitle = FALSE;
static volatile LONG lLockTipTextUpdate = 0;
static HFONT hFonTip = NULL;	//635@p5
static COLORREF colTipText;
static COLORREF colTipBack;

char format[1024];
char formatTooltip[LEN_TOOLTIP];
WCHAR formatTooltipW[LEN_TOOLTIP];
USRSTR usrstr[10];

char titleTooltip[300] = { 0 };
BOOL bHour12, bHourZero;
SYSTEMTIME LastTime;
int beatLast = -1;
int bDispSecond = FALSE;
int nDispBeat = 0;
BOOL bNoClock = FALSE;
int nBlink = 0;
BOOL bIE4 = FALSE, bWin95 = FALSE, bWin98 = FALSE,
	bWinNT = FALSE, bWin2000 = FALSE, bWinXP = FALSE,
	bVisualStyle = FALSE;
int dwidth = 0, dheight = 0, dvpos = 0, dlineheight = 0, dclkvpos = 0;
int iClockWidth = -1;
BOOL bPlaying = FALSE;
BOOL bDispSysInfo = FALSE, bTimerSysInfo = FALSE;
BOOL bGetSysRes = FALSE, bGetBattery = FALSE, bGetMem = FALSE,
     bGetMb = FALSE, bGetPm = FALSE, bGetNet = FALSE, bGetHdd = FALSE, bGetCpu = FALSE, bGetVol = FALSE;
int iFreeRes[3] = {0,0,0}, iCPUUsage = 0, iBatteryLife = 0, iCpuClock = 0, iVolume = 0;
MEMORYSTATUS msMemory;
BOOL bWatchTaskWnd = FALSE;
BOOL bClockShadow = FALSE;
BOOL bClockBorder = FALSE;
BOOL bVolRedraw = FALSE;
int nShadowRange = 1;
COLORREF colShadow;
int nTextPos = 0;
BOOL bFitClock = FALSE;  //390
BOOL bRClickMenu = FALSE;
int tEdgeTop;
int tEdgeLeft;
int tEdgeBottom;
int tEdgeRight;
int gConfigNo = 1;
//Addby Ђ܂
BOOL checknet=FALSE;
BOOL bGraph = FALSE;
BOOL bGraphTate = FALSE;
BOOL bReverseGraph = FALSE;
BOOL bGraphRedraw = FALSE;
int BackNetBand = 100;
int BackNetBand2 = 100;
int GraphL=0;
int GraphT=0;
int GraphR=0;
int GraphB=0;
int GraphType=1;
double sendlog[MAXGRAPHLOG+1] = { 0 };
double recvlog[MAXGRAPHLOG+1] = { 0 };
int ColSend,ColRecv,ColSR;
int graphInterval = 1;
int graphMode = 1;
int cpuHigh;

extern HWND hwndStart;
extern HWND hwndStartMenu;
extern BOOL bWin2000; //635@p5
extern BOOL bStartMenuClock; // startbtn.c
extern BOOL bSkinTray;
extern BOOL bFillTray;

extern int codepage;

// XButton Messages
#define WM_XBUTTONDOWN                  0x020B
#define WM_XBUTTONUP                    0x020C

/*------------------------------------------------
  initialize the clock
--------------------------------------------------*/
void InitClock(HWND hwnd)
{
	WIN32_FIND_DATA fd;
	HANDLE hfind;
	char fname[MAX_PATH];
	BOOL b;
	DWORD dw;
	int nDelay;
	
	if(hwndClock != NULL) return;
	hwndClock = hwnd;
	
	dw = GetVersion();
	bWin95 = (dw & 0x80000000);
	bWin98 = ((dw & 0x80000000) && 
		LOBYTE(LOWORD(dw)) >= 4 && HIBYTE(LOWORD(dw)) >= 10);
//	bWinME = ((dw & 0x80000000) && 
//		LOBYTE(LOWORD(dw)) >= 4 && HIBYTE(LOWORD(dw)) >= 90);
	bWinNT = !(dw & 0x80000000);
	bWin2000 = (!(dw & 0x80000000) && LOBYTE(LOWORD(dw)) >= 5);
	bWinXP = (!(dw & 0x80000000) && 
		LOBYTE(LOWORD(dw)) >= 5 && HIBYTE(LOWORD(dw)) >= 1);

	if(bWin2000) bWin98 = TRUE;

	dw = GetRegStr(HKEY_CURRENT_USER,
		"Software\\Microsoft\\Windows\\CurrentVersion\\ThemeManager",
		"DllName", fname, MAX_PATH, "");
	bVisualStyle = (dw>0)? TRUE:FALSE;

	GetModuleFileName(hmod, fname, MAX_PATH);
	del_title(fname); add_title(fname, "tclock.ini");
	hfind = FindFirstFile(fname, &fd);
	if(hfind != INVALID_HANDLE_VALUE)
	{
		g_bIniSetting = TRUE;
		strcpy(g_inifile, fname);
		FindClose(hfind);
	}
	
	CpuMoni_start(); // cpu.c
//	PerMoni_start(); // permon.c
	Net_start();     // net.c
	
	PostMessage(hwndTClockMain, WM_USER, 0, (LPARAM)hwnd);
	
	//WXgǂݍ
	ReadData(hwndClock);
	InitDaylightTimeTransition();
	//TuNX
	oldWndProc = (WNDPROC)GetWindowLong(hwndClock, GWL_WNDPROC);
	SetWindowLong(hwndClock, GWL_WNDPROC, (LONG)WndProc);
	//_uNbN󂯕tȂ
	SetClassLong(hwndClock, GCL_STYLE,
	  GetClassLong(hwndClock, GCL_STYLE) & ~CS_DBLCLKS);
	
	//fXNgbv̏
	SetDesktopIcons();
	//X^[g{^̏
	SetStartButton(hwndClock);
	//X^[gj[̏
	SetStartMenu(hwndClock);
	
	//c[`bv쐬
	CreateTip(hwndClock);
	
	b = GetMyRegLong(NULL, "DropFiles", FALSE);
	DragAcceptFiles(hwnd, b);
	
	bIE4 = IsIE4(hwndClock);
	if(bIE4)
	{
		InitStartMenuIE4();
		InitTaskSwitch(hwndClock);
	}
	
	InitTaskBarBorder(hwndClock);
	InitTrayNotify(hwndClock);
	
	if(bWin2000) SetLayeredTaskbar(hwndClock);
	if(bWin2000) InitLayeredStartMenu(hwndClock);
	
	//lbg[Nx
	nDelay = GetMyRegLong("", "DelayNet", 0);
	if(nDelay > 0)
	{
		SetTimer(hwnd, 7, nDelay * 1000, NULL);
	}
	
	//^XNo[̍XV
	PostMessage(GetParent(GetParent(hwndClock)), WM_SIZE,
		SIZE_RESTORED, 0);
	InvalidateRect(GetParent(GetParent(hwndClock)), NULL, TRUE);
}

/*------------------------------------------------
  ending process
--------------------------------------------------*/
void DeleteClockRes(void)
{
	if(hFon) DeleteObject(hFon); hFon = NULL;
	if(hFonTip) DeleteObject(hFonTip); hFonTip = NULL;	//635@p5
	if(hdcClock) DeleteDC(hdcClock); hdcClock = NULL;
	if(hbmpClock) DeleteObject(hbmpClock); hbmpClock = NULL;
}
void EndClock(void)
{
	DragAcceptFiles(hwndClock, FALSE);
	if(hwndTip) DestroyWindow(hwndTip); hwndTip = NULL;
	EndTrayNotify();
	EndTaskSwitch();
	EndTaskBarBorder();
	EndStartButton();
	EndStartMenu();
	EndDesktopIcons();
	ClearStartMenuIE4();
	
	DeleteClockRes();
	
	EndNewAPI(hwndClock);
	EndSysres();
	FreeBatteryLife();
	FreeCpuClock();
	CpuMoni_end(); // cpu.c
//	PerMoni_end(); // permon.c
	Net_end();     // net.c
	
	if(hwndClock && IsWindow(hwndClock))
	{
		if(bTimer) KillTimer(hwndClock, 1); bTimer = FALSE;
		if(bTimerSysInfo) KillTimer(hwndClock, 2);
		if(bWatchTaskWnd) KillTimer(hwndClock, 3); bWatchTaskWnd = FALSE;
		if(checknet) KillTimer(hwndClock, 4); checknet=FALSE;
		if(bGraphTimerStart) KillTimer(hwndClock, 5); bGraphTimerStart=FALSE;
		if(bTooltipTimerStart) KillTimer(hwndClock, 6); bTooltipTimerStart=FALSE;
		if (hwndClock && IsWindow(hwndClock))
		{
#if ENABLE_CHECK_SUBCLASS_NESTING
			if(oldWndProc && (WNDPROC)WndProc == (WNDPROC)GetWindowLong(hwndClock, GWL_WNDPROC))
#else
			if(oldWndProc)
#endif
				SetWindowLong(hwndClock, GWL_WNDPROC, (LONG)oldWndProc);
		}
		oldWndProc = NULL;
	}
//	hwndClock = NULL;	//ɂāA2EndClock邩Ȃ̂ŁA
						//NAȂ悤ɁB2ڂNULLɑ΂ăbZ[W
						//Ă܂A삪Ȃ錴ɂȂĂۂ
	//TClockEBhEI
	if(IsWindow(hwndTClockMain))
		PostMessage(hwndTClockMain, WM_USER+2, 0, 0);
}

/*------------------------------------------------
  IE 4 or later is installed ?
--------------------------------------------------*/
BOOL IsIE4(HWND hwnd)
{
	char classname[80];
	DWORD dw;
	
	dw = GetRegLong(HKEY_CURRENT_USER,
		"Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Explorer",
		"ClassicShell", 0);
	if(dw) return TRUE;
	
	hwnd = GetParent(GetParent(hwnd));
	if(hwnd == NULL) return FALSE;
	hwnd = GetWindow(hwnd, GW_CHILD);
	while(hwnd)
	{
		GetClassName(hwnd, classname, 80);
		if(lstrcmpi(classname, "ReBarWindow32") == 0)
			return TRUE;
		hwnd = GetWindow(hwnd, GW_HWNDNEXT);
	}
	return FALSE;
}


/*------------------------------------------------
  draw tooltip 
--------------------------------------------------*/
static void UpdateTooltip(HDC hdc, LPRECT lprcDraw, LPRECT lprect, UINT uDrawFlags)
{
	HGDIOBJ hOldFont;
	HBRUSH hBrushTipBack, hBrushTipText;
	RECT rc, rcall;
	LPSTR pszText;
	int maxwidth, width, height, len;
	LONG top;

	if (lprcDraw)
	{
		if (bTooltipBalloon)
		{
			UpdateTooltip(hdc, 0, &rc, uDrawFlags);
			rcall = *lprcDraw;
			if (bToolTipHasTitle) rcall.top += 22;
			rcall.bottom = rcall.top + (rc.bottom - rc.top);
		}
		else
		{
			UpdateTooltip(hdc, 0, &rc, uDrawFlags);
			rcall = *lprcDraw;
			rcall.top = rcall.bottom - (rc.bottom - rc.top);
			if (bToolTipHasTitle)
			{
				rcall.left += 10;
				rcall.top -= 8;
			}
		}
		hBrushTipText = CreateSolidBrush(colTipText);
		hBrushTipBack = CreateSolidBrush(colTipBack);
	}
	else
	{
		rcall.top = rcall.left = 0;
		rcall.right = rcall.bottom = 16384;
	}
	hOldFont = SelectObject(hdc, hFonTip);
	top = rcall.top;
	maxwidth = 0;
	InterlockedIncrement(&lLockTipTextUpdate);
	pszText = formatTooltip;
	while (*pszText)
	{
		len = 0;
		if (*pszText == 0x0d/*'\r'*/) pszText++;
		if (*pszText == 0x0a/*'\n'*/) pszText++;
		while (pszText[len] && pszText[len] != '\r' && pszText[len] != '\n') len++;
		rc = rcall;
		rc.top = top;
		if (len)
		{
			height = DrawText(hdc, pszText, len, &rc, uDrawFlags | DT_CALCRECT);
			width = rc.right - rc.left;
			if (maxwidth < width) maxwidth = width;
		}
		else
		{
			height = DrawText(hdc, " ", 1, &rc, uDrawFlags | DT_CALCRECT);
			width = 0;
		}
		if (lprcDraw)
		{
			int iOldMode;
			COLORREF colOldTipText, colOldTipBack;
			HDC hdcTemp;
			HBITMAP hbmpTemp;
			HGDIOBJ hbmpOld, hfonOld, hbrOld;
			hdcTemp= CreateCompatibleDC(hdc);
			if (hdcTemp)
			{
				hbmpTemp = CreateCompatibleBitmap(hdc, rcall.right - rcall.left, height);
				if (hbmpTemp)
				{
					hbmpOld = SelectObject(hdcTemp, hbmpTemp);
					hbrOld = SelectObject(hdcTemp, hBrushTipText);
					hfonOld = SelectObject(hdcTemp, hFonTip);
					colOldTipText = SetTextColor(hdcTemp, colTipText);
					colOldTipBack = SetBkColor(hdcTemp, colTipBack);
					iOldMode = SetBkMode(hdcTemp, TRANSPARENT);
					rc.top = 0;
					rc.bottom = height;
					rc.left = 0;
					rc.right = rcall.right - rcall.left;
					FillRect(hdcTemp, &rc, hBrushTipBack);
					if (len)
					{
						rc.top = 0;
						rc.bottom = height;
						rc.left = 0;
						rc.right = rcall.right - rcall.left;
						DrawText(hdcTemp, pszText, len, &rc, uDrawFlags);
					}
					BitBlt(hdc, rcall.left, top, rcall.right - rcall.left, height, hdcTemp, 0, 0, SRCCOPY);
					SetBkMode(hdcTemp, iOldMode);
					SetBkColor(hdcTemp, colOldTipBack);
					SetTextColor(hdcTemp, colOldTipText);
					SelectObject(hdcTemp, hfonOld);
					SelectObject(hdcTemp, hbrOld);
					SelectObject(hdcTemp, hbmpOld);
					DeleteObject(hbmpTemp);
				}
				DeleteDC(hdcTemp);
			}
		}
		top += height;
		pszText += len;
	}
	InterlockedDecrement(&lLockTipTextUpdate);
	SelectObject(hdc, hOldFont);
	if (lprcDraw)
	{
		if (top < rcall.bottom)
		{
			rc.top = top;
			rc.bottom = rcall.bottom;
			rc.left = rcall.left;
			rc.right = rcall.right;
			FillRect(hdc, &rc, hBrushTipBack);
		}
		DeleteObject(hBrushTipBack);
		DeleteObject(hBrushTipText);
	}
	if (lprect)
	{
		lprect->top = rcall.top;
		lprect->left = rcall.left;
		lprect->bottom = top;
		lprect->right = rcall.left + maxwidth;
	}
}

/*------------------------------------------------
  subclass procedure of the clock
--------------------------------------------------*/
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message) // c[`bvΉ
	{
		case WM_MOUSEMOVE:
		case WM_LBUTTONDOWN:
		case WM_RBUTTONDOWN:
		case WM_MBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_RBUTTONUP:
		case WM_MBUTTONUP:
		{
			MSG msg;
			msg.hwnd = hwnd;
			msg.message = message;
			msg.wParam = wParam;
			msg.lParam = lParam;
			msg.time = GetMessageTime();
			msg.pt.x = LOWORD(GetMessagePos());
			msg.pt.y = HIWORD(GetMessagePos());
			if(hwndTip)
				SendMessage(hwndTip, TTM_RELAYEVENT, 0, (LPARAM)&msg);
			break;
		}
	}
	
	switch(message)
	{
		case WM_DESTROY:
			DeleteClockRes();
			break;
		// eEBhE瑗ATCYԂbZ[W
		case (WM_USER+100):
			if(bNoClock) break;
			return OnCalcRect(hwnd);
		// VXe̐ݒ𔽉f
		case WM_SYSCOLORCHANGE:
			CreateClockDC(hwnd); //hdcClock蒼
		case WM_WININICHANGE:
		case WM_TIMECHANGE:
		// eEBhE瑗
		case (WM_USER+101):
		{
			HDC hdc;
			if(bNoClock) break;
			hdc = GetDC(hwnd);
			DrawClock(hwnd, hdc);
			ReleaseDC(hwnd, hdc);
			return 0;
		}
		//case WM_MOVE:
		//	if(bFitClock) { FitClock(); }
		//	CreateClockDC(hwnd);
		//	break;
		case WM_SIZE:
			CreateClockDC(hwnd); //hdcClock蒼
			break;
		case WM_ERASEBKGND:
			break;
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc;
			if(bNoClock) break;
			hdc = BeginPaint(hwnd, &ps);
			DrawClock(hwnd, hdc);
			EndPaint(hwnd, &ps);
			return 0;
		}
		case WM_TIMER:
			if(wParam == 1) OnTimer(hwnd);
			else if(wParam == 2)
				UpdateSysRes(hwnd, bGetSysRes, bGetBattery, bGetMem, bGetMb, bGetPm, bGetNet, bGetHdd, bGetCpu, bGetVol);
			else if(wParam == 3)
				OnTimerUpperTaskbar(hwnd);
			else if(wParam == 4)	//Add by Ђ܂
				Net_restart();	//net.c
			else if(wParam == 5)
				getGraphVal();
			else if(wParam == 6)
				OnTimerTooltip(hwnd);
			else if(wParam == 7)
			{
				KillTimer(hwnd, wParam);
				Net_restart();	//net.c
			}
			else
			{
				if(bNoClock) break;
			}
			return 0;
		// }EX_E
		case WM_LBUTTONDOWN:
		case WM_RBUTTONDOWN:
		case WM_MBUTTONDOWN:
		case WM_XBUTTONDOWN:
			if(nBlink)
			{
				nBlink = 0; InvalidateRect(hwnd, NULL, TRUE);
			}
			if(message == WM_LBUTTONDOWN && bStartMenuClock &&
				hwndStart && IsWindow(hwndStart))
			{
				SetWindowPos(hwndStart, NULL, 0, 0, 0, 0,
					SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
				// X^[gj[
				PostMessage(hwndStart, WM_LBUTTONDOWN, wParam, lParam);
				return 0;
			}
			if (message == WM_RBUTTONDOWN && (wParam & MK_LBUTTON || ((wParam&MK_CONTROL)&&(wParam&MK_SHIFT)) || bRClickMenu))
			{
				return 0;
			}
			
			PostMessage(hwndTClockMain, message, wParam, lParam);
			return 0;
		// }EXAbv
		case WM_LBUTTONUP:
		case WM_RBUTTONUP:
		case WM_MBUTTONUP:
		case WM_XBUTTONUP:
			if (message == WM_RBUTTONUP && (wParam & MK_LBUTTON || ((wParam&MK_CONTROL)&&(wParam&MK_SHIFT)) || bRClickMenu))
			{
				DWORD mp;
				mp = GetMessagePos();
				PostMessage(hwndTClockMain, WM_CONTEXTMENU, (WPARAM)hwnd, (LPARAM)mp);
				return 0;
			}
			PostMessage(hwndTClockMain, message, wParam, lParam);
			if(message == WM_RBUTTONUP) break;
			return 0;
		case WM_MOUSEMOVE:
			return 0;
		case WM_CONTEXTMENU:   // ENbNj[
			return 0;
		case WM_NCHITTEST: // oldWndProcɏȂ
			return DefWindowProc(hwnd, message, wParam, lParam);
		case WM_MOUSEACTIVATE:
			return MA_ACTIVATE;
		// t@C̃hbv
		case WM_DROPFILES:
			PostMessage(hwndTClockMain, WM_DROPFILES, wParam, lParam);
			return 0;
		case WM_NOTIFY: //c[`bṽeLXg\
		{
			if (!hwndTip || hwndTip != ((LPNMHDR)lParam)->hwndFrom) break;
			switch (((LPNMHDR)lParam)->code)
			{
				case NM_CUSTOMDRAW:
					if (bTipCustomDrawDisable) break;
					//if (!bTipUpdateEnable[iTipSelected]) break;
					if (((LPNMCUSTOMDRAW)lParam)->dwDrawStage == CDDS_PREPAINT)
					{
						if (((LPNMCUSTOMDRAW)lParam)->rc.top)
						{
							RECT rc;
							UpdateTooltip(((LPNMCUSTOMDRAW)lParam)->hdc, &((LPNMCUSTOMDRAW)lParam)->rc, &rc, ((LPNMTTCUSTOMDRAW)lParam)->uDrawFlags);
							//ValidateRect(hwndTip, &rc);
							ExcludeClipRect(((LPNMCUSTOMDRAW)lParam)->hdc, rc.left, rc.top, rc.right, rc.bottom);
						}
						else
						{
							//ValidateRect(hwndTip, &((LPNMCUSTOMDRAW)lParam)->rc);
							ExcludeClipRect(((LPNMCUSTOMDRAW)lParam)->hdc, ((LPNMCUSTOMDRAW)lParam)->rc.left, ((LPNMCUSTOMDRAW)lParam)->rc.top, ((LPNMCUSTOMDRAW)lParam)->rc.right, ((LPNMCUSTOMDRAW)lParam)->rc.bottom);
						}
						return CDRF_NOTIFYPOSTPAINT;
					}
#if 1
					/* KvH */
					if (((LPNMCUSTOMDRAW)lParam)->dwDrawStage == CDDS_POSTPAINT)
					{
						HRGN hrgn = CreateRectRgn(((LPNMCUSTOMDRAW)lParam)->rc.left, ((LPNMCUSTOMDRAW)lParam)->rc.top, ((LPNMCUSTOMDRAW)lParam)->rc.right, ((LPNMCUSTOMDRAW)lParam)->rc.bottom);
						if (hrgn)
						{
							ExtSelectClipRgn(((LPNMCUSTOMDRAW)lParam)->hdc, hrgn, RGN_OR);
							DeleteObject(hrgn);
						}
						return 0;
					}
#endif
					break;
				case TTN_NEEDTEXTW:
					if (!bTooltipShow || !bTooltipUpdated)
					{
						UpdateTooltipText();
						UpdateTooltipTitle();
					}
					MultiByteToWideChar(CP_ACP, 0, formatTooltip, -1,
						formatTooltipW, sizeof(formatTooltipW)/sizeof(WCHAR));
					((LPTOOLTIPTEXTW)lParam)->lpszText = formatTooltipW;
					return 0;
				case TTN_NEEDTEXT:
					if (!bTooltipShow || !bTooltipUpdated)
					{
						UpdateTooltipText();
						UpdateTooltipTitle();
					}
					((LPTOOLTIPTEXT)lParam)->lpszText = formatTooltip;
					return 0;
				case TTN_SHOW:
					if (!bTooltipShow)
					{
						UpdateTooltipText();
						UpdateTooltipTitle();
						SetWindowPos(hwndTip, HWND_TOPMOST, 0, 0, 0, 0,
							SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
						bTooltipShow = TRUE;
					}
					break;
				case TTN_POP:
					bTooltipShow = FALSE;
					bTooltipUpdated = FALSE;
					break;
			}
			break;
		}
		case WM_COMMAND:
			if(LOWORD(wParam) == 102) EndClock();
			return 0;
		case CLOCKM_REFRESHCLOCK: // refresh the clock
		{
			BOOL b;
			COLORREF tcolf, tcolb;
			ReadData(hwnd);
			//390CreateClockDC(hwnd);
			b = GetMyRegLong(NULL, "DropFiles", FALSE);
			DragAcceptFiles(hwnd, b);
			InvalidateRect(hwnd, NULL, FALSE);
			InvalidateRect(GetParent(hwndClock), NULL, TRUE);
			//return 0; //390
			//635@p5
			tcolf = tipFonCol; tcolb = tipBakCol;
			if(tcolf & 0x80000000) tcolf = GetSysColor(tcolf & 0x00ffffff);
			if(tcolb & 0x80000000) tcolb = GetSysColor(tcolb & 0x00ffffff);
			if(hwndTip)
			{
				LONG exstyle;
				BOOL bTipEnableDoubleBuffering;
				bTipEnableDoubleBuffering = GetMyRegLong("Tooltip", "TipEnableDoubleBuffering", FALSE);
				exstyle = GetWindowLong(hwnd, GWL_EXSTYLE) & ~WS_EX_COMPOSITED;
				SetWindowLong(hwnd, GWL_EXSTYLE, exstyle | (bTipEnableDoubleBuffering ? WS_EX_COMPOSITED : 0));
				SendMessage(hwndTip, WM_SETFONT, (WPARAM)hFonTip, TRUE);
				SendMessage(hwndTip, TTM_SETTIPBKCOLOR, tcolb, 0);
				SendMessage(hwndTip, TTM_SETTIPTEXTCOLOR, tcolf, 0);
				SendMessage(hwndTip, TTM_SETDELAYTIME, TTDT_AUTOPOP, MAKELONG(tipDispTime*1000,0));
				if(bWin2000) SetLayeredToolTips(hwndTip,(INT)(25500-255*alphaTip)/100);
			}
		}
		case CLOCKM_REFRESHTASKBAR: // refresh other elements than clock
			SetDesktopIcons();
			SetStartButton(hwnd);
			SetStartMenu(hwnd);
			if(bIE4)
			{
				InitStartMenuIE4();
				InitTaskSwitch(hwnd);
			}
			InitTaskBarBorder(hwnd);
			InitTrayNotify(hwnd);
			CreateClockDC(hwnd);
			if(bWin2000) SetLayeredTaskbar(hwndClock);
			if(bWin2000) InitLayeredStartMenu(hwndClock);
			PostMessage(GetParent(GetParent(hwnd)), WM_SIZE,
				SIZE_RESTORED, 0);
			InvalidateRect(GetParent(GetParent(hwndClock)), NULL, TRUE);
			return 0;
		case CLOCKM_BLINK: // blink the clock
			if(wParam) { if(nBlink == 0) nBlink = 4; }
			else nBlink = 2;
			if(lParam) { nBlink = 0; }
			return 0;
		case CLOCKM_COPY: // copy format to clipboard
			OnCopy(hwnd, lParam);
			return 0;
		case CLOCKM_REFRESHDESKTOP:
			SetDesktopIcons();
			return 0;
		case CLOCKM_VOLCHANGE:
			if(bGetVol)
			{
				BOOL muteflg;
				GetMasterVolume(&iVolume);
				GetMasterMute(&muteflg);
				if (muteflg)
					iVolume = 0;
				bVolRedraw = TRUE;
				OnTimer(hwnd);
				return 0;
			}
			else
				return 0;
		case CLOCKM_NETINIT:
			Net_restart();	//net.c
			return 0;
		case CLOCKM_DELUSRSTR:
			{
				int i;
				for(i=0;i<10;i++) { lstrcpy(usrstr[i].u_str,""); }
				return 0;
			}
		case WM_COPYDATA:
			OnCopyData((HWND)wParam,(COPYDATASTRUCT*)lParam);
			return 0;
		case WM_WINDOWPOSCHANGING:  // TCY
			{
				static RECT rcOld = { 1,0,0,0 };
				RECT rc;
				GetWindowRect(GetParent(hwnd), &rc);
				if ((bFitClock && EqualRect(&rcOld, &rc)))
				{
					((LPWINDOWPOS)lParam)->flags |= SWP_NOSIZE | SWP_NOMOVE;
					break;
				}
				rcOld = rc;
			}
			if(bNoClock) break;
			if(!bWinXP || !bVisualStyle)
			{
				LPWINDOWPOS pwp;
				pwp = (LPWINDOWPOS)lParam;
				if(IsWindowVisible(hwnd) && !(pwp->flags & SWP_NOSIZE))
				{
					int h;
					h = (int)HIWORD(OnCalcRect(hwnd));
					if(pwp->cy > h) pwp->cy = h;
				}
				break;
			}
			else
			{
				//WinXP Visual Style
				LPWINDOWPOS pwp;
				RECT rc,rcBar;
				
				pwp = (LPWINDOWPOS)lParam;
				if(IsWindowVisible(hwnd) && !(pwp->flags & SWP_NOSIZE))
				{
					int h;//,w;
					h = (int)HIWORD(OnCalcRect(hwnd));
					//w = (int)LOWORD(OnCalcRect(hwnd));
					if(pwp->cy > h) pwp->cy = h;
					
					GetWindowRect(GetParent(hwndClock),&rc);
					GetWindowRect(GetParent(GetParent(hwndClock)),&rcBar);
					
					if((rcBar.right - rcBar.left) > (rcBar.bottom - rcBar.top))
					{
						//u
						pwp->y = ((rc.bottom - rc.top) - pwp->cy) / 2;
						pwp->x = ((rc.right - rc.left) - pwp->cx);// - 3;
					}else{
						//cu
						pwp->y = ((rc.bottom - rc.top) - pwp->cy);// - 3;
						pwp->x = ((rc.right - rc.left) - pwp->cx) / 2;
					}
				}
				break;
			}
			break;
	}
	/*
	{
		char s[80];
		wsprintf(s, "%X", message);
		WriteDebug(s);
	}
	*/
	return CallWindowProc(oldWndProc, hwnd, message, wParam, lParam);
}

/*------------------------------------------------
@ݒ̓ǂݍ݂ƃf[^̏
--------------------------------------------------*/
void ReadData(HWND hwnd)
{
	char fontname[80];
	int fontsize;
	LONG weight, italic, b_flg;
	SYSTEMTIME lt;
	DWORD dwInfoFormat;
	int resnetinterval;

	//ݒԍ擾
	gConfigNo = GetMyRegLong(NULL,"ConfigNo",1);
	
	colfore = GetMyRegLongEx(NULL, "ForeColor", 
		0x80000000 | COLOR_BTNTEXT, gConfigNo);
	colback = GetMyRegLongEx(NULL, "BackColor",
		0x80000000 | COLOR_3DFACE, gConfigNo);
	if(GetMyRegLongEx(NULL, "UseBackColor2", TRUE, gConfigNo))
		colback2 = GetMyRegLongEx(NULL, "BackColor2", colback, gConfigNo);
	else colback2 = colback;
	fillbackcolor = GetMyRegLongEx(NULL, "UseBackColor", TRUE, gConfigNo);
	grad = GetMyRegLongEx(NULL, "GradDir", GRADIENT_FILL_RECT_H, gConfigNo);
	
	bClockShadow = GetMyRegLongEx(NULL, "UseClockShadow", FALSE, gConfigNo);
	bClockBorder = GetMyRegLongEx(NULL, "UseClockBorder", FALSE, gConfigNo);
	colShadow = GetMyRegLongEx(NULL, "ShadowColor", RGB(0, 0, 0), gConfigNo);
	nShadowRange = (int)(short)GetMyRegLongEx(NULL, "ClockShadowRange", 1, gConfigNo);
	
	bRClickMenu = GetMyRegLong(NULL, "RightClickMenu", TRUE);
	
	GetMyRegStrEx(NULL, "Font", fontname, 80, "", gConfigNo);
	
	fontsize = GetMyRegLongEx(NULL, "FontSize", 9, gConfigNo);
	weight = GetMyRegLongEx(NULL, "Bold", 0, gConfigNo);
	if(weight) weight = FW_BOLD;
	else weight = 0;
	italic = GetMyRegLongEx(NULL, "Italic", 0, gConfigNo);
	
	if(hFon) DeleteObject(hFon);
	hFon = CreateMyFont(fontname, fontsize, weight, italic);
	
	//635@p5
	GetMyRegStrEx(NULL, "TipFont", fontname, 80, "", gConfigNo);
	
	fontsize = GetMyRegLongEx(NULL, "TipFontSize", 9, gConfigNo);
	weight = GetMyRegLongEx(NULL, "TipBold", 0, gConfigNo);
	if(weight) weight = FW_BOLD;
	else weight = 0;
	italic = GetMyRegLongEx(NULL, "TipItalic", 0, gConfigNo);
	
	if(hFonTip) DeleteObject(hFonTip);
	hFonTip = CreateMyFont(fontname, fontsize, weight, italic);
	b_flg = GetMyRegLong(NULL, "BalloonFlg", 0);
	if(b_flg) balloonFlg = TTS_BALLOON/* | TTS_NOANIMATE | TTS_NOFADE*/;
	alphaTip = (int)(short)GetMyRegLongEx(NULL, "AlphaTip", 255, gConfigNo);
	tipDispTime = (int)(short)GetMyRegLong(NULL, "TipDispTime", 5);
	bTipCustomDrawDisable = GetMyRegLong("Tooltip", "TipDisableCustomDraw", 0);
	bTipUpdateEnable[0] = GetMyRegLong("Tooltip", "Tip1Update", 0);
	bTipUpdateEnable[1] = GetMyRegLong("Tooltip", "Tip2Update", 0);
	bTipUpdateEnable[2] = GetMyRegLong("Tooltip", "Tip3Update", 0);
	iTipDispInterval = (int)(short)GetMyRegLong("Tooltip", "TipDispInterval", 1);
	if (iTipDispInterval > 30) iTipDispInterval = 30;
	if (iTipDispInterval < 1) iTipDispInterval = 1;
	if (bTooltipTimerStart) KillTimer(hwndClock, 6); bTooltipTimerStart = FALSE;
	bTooltipTimerStart = SetTimer(hwndClock, 6, iTipDispInterval*1000, NULL) != 0;
	tipFonCol = GetMyRegLongEx(NULL, "TipFonColor", 
		0x80000000 | COLOR_INFOTEXT, gConfigNo);
	tipBakCol = GetMyRegLongEx(NULL, "TipBakColor", 
		0x80000000 | COLOR_INFOBK, gConfigNo);
	
	{
		COLORREF tcolf, tcolb;
		tcolf = tipFonCol; tcolb = tipBakCol;
		if(tcolf & 0x80000000) tcolf = GetSysColor(tcolf & 0x00ffffff);
		if(tcolb & 0x80000000) tcolb = GetSysColor(tcolb & 0x00ffffff);
		colTipText = tcolf;
		colTipBack = tcolb;
	}
	
	//end
	
	nTextPos = GetMyRegLongEx(NULL, "TextPos", 0, gConfigNo);
	
	dheight = (int)(short)GetMyRegLongEx(NULL, "ClockHeight", 0, gConfigNo);
	dwidth = (int)(short)GetMyRegLongEx(NULL, "ClockWidth", 0, gConfigNo);
	dvpos = (int)(short)GetMyRegLongEx(NULL, "VertPos", 0, gConfigNo);
	dlineheight = (int)(short)GetMyRegLongEx(NULL, "LineHeight", 0, gConfigNo);
	dclkvpos = (int)(short)GetMyRegLongEx(NULL, "ClockVertPos", 0, gConfigNo);
	
	//from tclock2
	tEdgeTop = (int)(short)GetMyRegLong("Clock", "ClockSkinEdgeTop", 1);
	if(tEdgeTop < 1) tEdgeTop = 1;
	tEdgeLeft = (int)(short)GetMyRegLong("Clock", "ClockSkinEdgeLeft", 1);
	if(tEdgeLeft < 1) tEdgeLeft = 1;
	tEdgeBottom = (int)(short)GetMyRegLong("Clock", "ClockSkinEdgeBottom", 1);
	if(tEdgeBottom < 1) tEdgeBottom = 1;
	tEdgeRight = (int)(short)GetMyRegLong("Clock", "ClockSkinEdgeRight", 1);
	if(tEdgeRight < 1) tEdgeRight = 1;
	
	//390 Beep(4000,500);
	bFitClock = GetMyRegLong(NULL, "FitClock", FALSE);
	
	resnetinterval = GetMyRegLong(NULL, "NetRestartInterval", 0);
	checknet = GetMyRegLong(NULL, "DoNetRestart", FALSE);
	KillTimer(hwndClock, 4);
	if(checknet) SetTimer(hwndClock, 4, resnetinterval*1000, NULL);
	bGraph = GetMyRegLong(NULL, "BackNet", FALSE);
	bReverseGraph = GetMyRegLong(NULL, "ReverseGraph", FALSE);
	bGraphTate = GetMyRegLong(NULL, "GraphTate", FALSE);
	BackNetBand = GetMyRegLong(NULL, "BackNetBand", 100);
	BackNetBand2 = GetMyRegLong(NULL, "BackNetBand2", 100);
	ColSend = GetMyRegLong(NULL, "BackNetColSend", 0x000000ff);
	ColRecv = GetMyRegLong(NULL, "BackNetColRecv", 0x00ff0000); 
	ColSR = GetMyRegLong(NULL, "BackNetColSR", 0x00800080);
	graphInterval = GetMyRegLong(NULL, "GraphInterval", 1);
	graphMode = GetMyRegLong(NULL, "GraphMode", 1);
	cpuHigh = GetMyRegLong(NULL, "CpuHigh", 70);
	GraphL = GetMyRegLong(NULL, "GraphLeft", 0);
	GraphT = GetMyRegLong(NULL, "GraphTop", 0);
	GraphR = GetMyRegLong(NULL, "GraphRight", 1);
	GraphB = GetMyRegLong(NULL, "GraphBottom", 1);
	GraphType = GetMyRegLong(NULL, "GraphType", 1);
	
	if(bGraphTimerStart) KillTimer(hwndClock, 5); bGraphTimerStart = FALSE;
	if(bGraph)
		bGraphTimerStart = SetTimer(hwndClock, 5, graphInterval*1000, NULL) != 0;
	
	bNoClock = GetMyRegLong(NULL, "NoClock", FALSE);
	
	if(!GetMyRegStrEx(NULL, "Format", format, 1024, "", gConfigNo) || !format[0])
	{
		bNoClock = TRUE;
	}
	
	if(bWatchTaskWnd) KillTimer(hwndClock, 3);
	bWatchTaskWnd = GetMyRegLong(NULL, "WatchTaskbarWindow", FALSE);
	if(bWatchTaskWnd) SetTimer(hwndClock, 3, 200, NULL);
	
	dwInfoFormat = FindFormat(format);
	bDispSecond = (dwInfoFormat&FORMAT_SECOND)? TRUE:FALSE;
	nDispBeat = dwInfoFormat & (FORMAT_BEAT1 | FORMAT_BEAT2);
	if(!bTimer) SetTimer(hwndClock, 1, 1000, NULL);
	bTimer = TRUE;
	
	bHour12 = GetMyRegLong(NULL, "Hour12", 0);
	bHourZero = GetMyRegLong(NULL, "HourZero", 0);
	
	GetLocalTime(&lt);
	LastTime.wDay = lt.wDay;
	
	InitFormat(&lt);      // format.c
	
	iClockWidth = -1;
	
	InitSysInfo(hwnd);
}

void InitSysInfo(HWND hwnd)
{
	DWORD dwInfoFormat, dwInfoTip, dwInfoTitle;
	char tip[LEN_TOOLTIP], tip2[LEN_TOOLTIP], tip3[LEN_TOOLTIP];
	char tiptitle[300]; //635@p5
	//	ToolTip̃eLXgWXgǂݍ
	GetMyRegStrEx("Tooltip", "Tooltip", tip, sizeof(tip), "", gConfigNo);
	//t@Cwłꍇ
	if(tip[0] == 'f' && tip[1] == 'i' && tip[2] == 'l' && tip[3] == 'e' && tip[4] == ':')
	{
		//Path؂o
		memmove( tip, tip + 5, (size_t)((strchr(tip,'\0')-1)-tip));
		if(!GetToolTipText(tip)){
			strcpy(tip, "\"t@C擾s\"\\n\\nLDATE hh:nn:ss");
		}
	}
	//	ToolTip̃eLXgWXgǂݍ
	GetMyRegStrEx("Tooltip", "Tooltip2", tip2, sizeof(tip2), "", gConfigNo);
	//t@Cwłꍇ
	if(tip2[0] == 'f' && tip2[1] == 'i' && tip2[2] == 'l' && tip2[3] == 'e' && tip2[4] == ':')
	{
		//Path؂o
		memmove( tip2, tip2 + 5, (size_t)((strchr(tip2,'\0')-1)-tip2));
		if(!GetToolTipText(tip2)){
			strcpy(tip2, "\"t@C擾s\"\\n\\nLDATE hh:nn:ss");
		}
	}
	//	ToolTip̃eLXgWXgǂݍ
	GetMyRegStrEx("Tooltip", "Tooltip3", tip3, sizeof(tip3), "", gConfigNo);
	//t@Cwłꍇ
	if(tip3[0] == 'f' && tip3[1] == 'i' && tip3[2] == 'l' && tip3[3] == 'e' && tip3[4] == ':')
	{
		//Path؂o
		memmove( tip3, tip3 + 5, (size_t)((strchr(tip3,'\0')-1)-tip3));
		if(!GetToolTipText(tip3)){
			strcpy(tip3, "\"t@C擾s\"\\n\\nLDATE hh:nn:ss");
		}
	}
	GetMyRegStrEx("", "TipTitle", tiptitle, 300, "", gConfigNo); //635@p5
	
	if(bTimerSysInfo) KillTimer(hwndClock, 2);
	
	bDispSysInfo = bTimerSysInfo = FALSE;
	bGetSysRes = bGetBattery = bGetMem = FALSE;
	memset(&msMemory, 0, sizeof(msMemory));
	
	dwInfoFormat = FindFormat(format);
	dwInfoTip    = FindFormat(tip) | FindFormat(tip2) | FindFormat(tip3);
	dwInfoTitle  = FindFormat(tiptitle); //635@p5
	
	bGetSysRes = (((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_SYSINFO))? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_SYSINFO) bDispSysInfo = TRUE;
	
	if(bWin95 || bWin2000)
	{
		bGetBattery = ((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_BATTERY)? TRUE:FALSE;
		if(dwInfoFormat & FORMAT_BATTERY) bDispSysInfo = TRUE;
	}
	
	bGetMem = ((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_MEMORY)? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_MEMORY) bDispSysInfo = TRUE;
	
	bGetMb = ((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_MOTHERBRD)? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_MOTHERBRD) bDispSysInfo = TRUE;
	
	bGetPm = ((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_PERMON)? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_PERMON) bDispSysInfo = TRUE;
	
	bGetNet = (((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_NET)||(bGraph&&graphMode==1))? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_NET) bDispSysInfo = TRUE;
	
	bGetHdd = ((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_HDD)? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_HDD) bDispSysInfo = TRUE;
	
	bGetCpu = ((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_CPU)? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_CPU) bDispSysInfo = TRUE;
	
	bGetVol = ((dwInfoFormat | dwInfoTip | dwInfoTitle) & FORMAT_VOL)? TRUE:FALSE;
	if(dwInfoFormat & FORMAT_VOL) bDispSysInfo = TRUE;
	
	if(bGetSysRes || bGetBattery || bGetMem || bGetMb || bGetPm || bGetNet || bGetHdd || bGetCpu || bGetVol)
	{
		int interval;

		bTimerSysInfo = TRUE;
		UpdateSysRes(hwnd, bGetSysRes, bGetBattery, bGetMem, bGetMb, bGetPm, bGetNet, bGetHdd, bGetCpu, bGetVol);
		interval = (int)GetMyRegLong(NULL, "IntervalSysInfo", 5);
		if(interval <= 0 || 60 < interval) interval = 5;
		SetTimer(hwndClock, 2, interval * 1000, NULL);
	}
}

/*------------------------------------------------
@c[`bvEBhE̍쐬
--------------------------------------------------*/
void CreateTip(HWND hwnd)
{
	TOOLINFO ti;
	COLORREF tcolf, tcolb;
	BOOL bTipEnableDoubleBuffering;
	bTipEnableDoubleBuffering = GetMyRegLong("Tooltip", "TipEnableDoubleBuffering", FALSE);
		hwndTip = CreateWindowEx((bTipEnableDoubleBuffering ? WS_EX_COMPOSITED : 0) | WS_EX_LAYERED, TOOLTIPS_CLASS, (LPSTR)NULL,
			TTS_ALWAYSTIP | TTS_NOPREFIX | balloonFlg,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			NULL, NULL, hmod, NULL); 
	if(!hwndTip) return;

	SetWindowPos(hwndTip, HWND_TOPMOST, 0, 0, 0, 0,
		SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);

	bTooltipBalloon = (GetWindowLong(hwndTip, GWL_STYLE) & TTS_BALLOON) != 0;
	//635@p5
	if(bWin2000) SetLayeredToolTips(hwndTip,(25500-255*alphaTip)/100);
	
	ti.cbSize = sizeof(TOOLINFO); 
	ti.uFlags = 0;
	ti.hwnd = hwnd;
	ti.hinst = NULL;
	ti.uId = 1;
	ti.lpszText = LPSTR_TEXTCALLBACK;
	ti.rect.left = 0;
	ti.rect.top = 0;
	ti.rect.right = 480; 
	ti.rect.bottom = 480;
	SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO)&ti);
	SendMessage(hwndTip, TTM_SETMAXTIPWIDTH, 0, (LPARAM) LEN_TOOLTIP);
	//635@p5
	tcolf = tipFonCol; tcolb = tipBakCol;
	if(tcolf & 0x80000000) tcolf = GetSysColor(tcolf & 0x00ffffff);
	if(tcolb & 0x80000000) tcolb = GetSysColor(tcolb & 0x00ffffff);
	SendMessage(hwndTip, WM_SETFONT, (WPARAM)hFonTip, TRUE);
	SendMessage(hwndTip, TTM_SETTIPBKCOLOR, tcolb, 0);
	SendMessage(hwndTip, TTM_SETTIPTEXTCOLOR, tcolf, 0);
#if 0
	{
		RECT rc;
		rc.top = rc.bottom = rc.left = rc.right = 20;
		SendMessage(hwndTip, TTM_SETMARGIN, 0, (LPARAM)(LPRECT)&rc);
	}
#endif
	SendMessage(hwndTip, TTM_SETDELAYTIME, TTDT_AUTOPOP, MAKELONG(tipDispTime*1000,0));
	SendMessage(hwndTip, TTM_ACTIVATE, TRUE, 0);
}

/*------------------------------------------------
@`pDC̍쐬
--------------------------------------------------*/
void CreateClockDC(HWND hwnd)
{
	RECT rc;
	COLORREF col;
	HDC hdc;
	char s[1024];
	
	//390vTCYE܂
	if(bFitClock) { FitClock(); }
	else {
		if(!GetMyRegLong(NULL, "FlatTray", FALSE)){
			//`H
			SetMyRegLong(NULL, "FlatTray",TRUE);
			InitTrayNotify(hwndClock);
			SetMyRegLong(NULL, "FlatTray",FALSE);
			InitTrayNotify(hwndClock);
		}
	}
	//---------

	if(hdcClock)
	{
		if (hbmpClockOld) SelectObject(hdcClock, hbmpClockOld);
		DeleteDC(hdcClock);
		hdcClock = NULL;
	}
	if(hbmpClock) DeleteObject(hbmpClock); hbmpClock = NULL;
	if(hbmpClockSkin) DeleteObject(hbmpClockSkin); hbmpClockSkin = NULL;
	
	if(bNoClock) return;
	
	if(bFillTray && (fillbackcolor || bSkinTray))
		hwnd = GetParent(hwnd);
	
	GetClientRect(hwnd, &rc);
	
	hdc = GetDC(NULL);
	
	hdcClock = CreateCompatibleDC(hdc);
	if(!hdcClock)
	{
		ReleaseDC(NULL, hdc);
		return;
	}
	hbmpClock = CreateCompatibleBitmap(hdc, rc.right, rc.bottom);
	
	if(bSkinTray)
	{
		if(GetMyRegStr("Clock", "ClockSkin", s, 1024, "") > 0)
		{
			hbmpClockSkin = ReadBitmap(hwnd, s, TRUE);
		}
	}
	
	if(!hbmpClock)
	{
		DeleteDC(hdcClock); hdcClock = NULL;
		ReleaseDC(NULL, hdc);
		return;
	}
	hbmpClockOld = SelectObject(hdcClock, hbmpClock);
	
	SelectObject(hdcClock, hFon);
	SetBkMode(hdcClock, TRANSPARENT);
	if(nTextPos == 1)
		SetTextAlign(hdcClock, TA_LEFT|TA_TOP);
	else if(nTextPos == 2)
		SetTextAlign(hdcClock, TA_RIGHT|TA_TOP);
	else
		SetTextAlign(hdcClock, TA_CENTER|TA_TOP);
	col = colfore;
	if(col & 0x80000000) col = GetSysColor(col & 0x00ffffff);
	SetTextColor(hdcClock, col);
	
	FillClock(hwnd, hdcClock, &rc, 0);
	
	ReleaseDC(NULL, hdc);
}

/*------------------------------------------------
   get date/time and beat to display
--------------------------------------------------*/
void GetDisplayTime(SYSTEMTIME* pt, int* beat100)
{
	FILETIME ft, lft;
	SYSTEMTIME lt;
	
	GetSystemTimeAsFileTime(&ft);
	
	if(beat100)
	{
		DWORDLONG dl;
		SYSTEMTIME st;
		int sec;
		
		dl = *(DWORDLONG*)&ft + 36000000000;
		FileTimeToSystemTime((FILETIME*)&dl, &st);
		
		sec = st.wHour * 3600 + st.wMinute * 60 + st.wSecond;
		*beat100 = (sec * 1000) / 864;
	}
	
	FileTimeToLocalFileTime(&ft, &lft);
	FileTimeToSystemTime(&lft, &lt);
	memcpy(pt, &lt, sizeof(lt));
}

/*------------------------------------------------
@WM_TIMER ̏
--------------------------------------------------*/
void OnTimer(HWND hwnd)
{
	SYSTEMTIME t;
	int beat100;
	HDC hdc;
	BOOL bRedraw;

	GetDisplayTime(&t, nDispBeat?(&beat100):NULL);
	
	if((t.wMilliseconds > 200 || (bWinNT && t.wMilliseconds > 50))&&(!bVolRedraw))
	{
		KillTimer(hwnd, 1);
		bTimerTesting = TRUE;
		SetTimer(hwnd, 1, 1001 - t.wMilliseconds, NULL);
	}
	else if(bTimerTesting)
	{
		KillTimer(hwnd, 1);
		bTimerTesting = FALSE;
		SetTimer(hwnd, 1, 1000, NULL);
	}
	if (bVolRedraw)
		bVolRedraw = FALSE;
	if(CheckDaylightTimeTransition(&t))
	{
		CallWindowProc(oldWndProc, hwnd, WM_TIMER, 0, 0);
		GetDisplayTime(&t, nDispBeat?(&beat100):NULL);
	}
	
	bRedraw = FALSE;
	if(nBlink > 0) bRedraw = TRUE;
	else if(bDispSecond) bRedraw = TRUE;
	else if(nDispBeat == FORMAT_BEAT1 && beatLast != (beat100/100)) bRedraw = TRUE;
	else if(nDispBeat == FORMAT_BEAT2 && beatLast != beat100) bRedraw = TRUE;
	else if(bDispSysInfo) bRedraw = TRUE;
	else if(LastTime.wHour != (int)t.wHour 
		|| LastTime.wMinute != (int)t.wMinute) bRedraw = TRUE;
	else if(bGraphRedraw)
	{
		bGraphRedraw = FALSE;
		bRedraw = TRUE;
	}
	
	if(bNoClock) bRedraw = FALSE;
	
	if(LastTime.wDay != t.wDay || LastTime.wMonth != t.wMonth ||
		LastTime.wYear != t.wYear)
	{
		InitFormat(&t); // format.c
		InitDaylightTimeTransition();
	}
	
	hdc = NULL;
	if(bRedraw) hdc = GetDC(hwnd);
	
	memcpy(&LastTime, &t, sizeof(t));
	
	if(nDispBeat == FORMAT_BEAT1) beatLast = beat100/100;
	else if(nDispBeat == FORMAT_BEAT2) beatLast = beat100;
	
	if(nBlink >= 3 && t.wMinute == 1) nBlink = 0;
	if(hdc)
	{
		DrawClockSub(hwnd, hdc, &t, beat100); //`
		ReleaseDC(hwnd, hdc);
	}
	
	if(nBlink)
	{
		if(nBlink % 2) nBlink++;
		else nBlink--;
	}
	
	CheckCursorOnStartButton();

	SetDesktopIcons();
}

void OnTimerUpperTaskbar(HWND hwnd)
{
	RECT rectTaskbar, rectWnd, rectClient;
	HWND hActiveWnd;
	if (!hwndTaskbar) return;
	if (!GetWindowRect(hwndTaskbar, &rectTaskbar)) return;

	hActiveWnd = GetForegroundWindow();
	if (!GetWindowRect(hActiveWnd, &rectWnd)) return;
	if (rectWnd.top == rectWnd.bottom) return;
	if (rectWnd.left == rectWnd.right) return;
	if (IsZoomed(hActiveWnd)
	 || !IsWindowVisible(hActiveWnd)
	 || (rectWnd.bottom-rectWnd.top) >= GetSystemMetrics(SM_CYFULLSCREEN)
	 || (rectWnd.right-rectWnd.left) >= GetSystemMetrics(SM_CXFULLSCREEN))
		return;
	//ufXNgbv̕\vōŏꂽEBhE𕜌Ƃ
	//EBhEʒuȂ
	if (!GetClientRect(hActiveWnd, &rectClient)) return;
	if (rectClient.right == 0 && rectClient.bottom == 0) return;

	if (rectTaskbar.bottom <= (GetSystemMetrics(SM_CYSCREEN)/2))
	{
		//^XNo[
		if (rectWnd.top < rectTaskbar.bottom)
		{
			MoveWindow(hActiveWnd, rectWnd.left, rectTaskbar.bottom,
				rectWnd.right-rectWnd.left, rectWnd.bottom-rectWnd.top, TRUE);
		}
	}
	else
	if (rectTaskbar.right <= (GetSystemMetrics(SM_CXSCREEN)/2))
	{
		//^XNo[
		if (rectWnd.left < rectTaskbar.right)
		{
			MoveWindow(hActiveWnd, rectTaskbar.right, rectWnd.top,
				rectWnd.right-rectWnd.left, rectWnd.bottom-rectWnd.top, TRUE);
		}
	}
	else
	if (rectTaskbar.left >= (GetSystemMetrics(SM_CXSCREEN)/2))
	{
		//E^XNo[
		if (rectWnd.right > rectTaskbar.left)
		{
			MoveWindow(hActiveWnd, rectTaskbar.left-(rectWnd.right-rectWnd.left) , rectWnd.top,
				rectWnd.right-rectWnd.left, rectWnd.bottom-rectWnd.top, TRUE);
		}
	}
	else
	{
		//^XNo[
		if (rectWnd.bottom > rectTaskbar.top)
		{
			MoveWindow(hActiveWnd, rectWnd.left, rectTaskbar.top-(rectWnd.bottom-rectWnd.top),
				rectWnd.right-rectWnd.left, rectWnd.bottom-rectWnd.top, TRUE);
		}
	}
}

/*------------------------------------------------
@v̕`
--------------------------------------------------*/
void DrawClock(HWND hwnd, HDC hdc)
{
	SYSTEMTIME t;
	int beat100;
	
	GetDisplayTime(&t, nDispBeat?(&beat100):NULL);
	DrawClockSub(hwnd, hdc, &t, beat100);
}

/*------------------------------------------------
  draw the clock
--------------------------------------------------*/
void DrawClockSub(HWND hwnd, HDC hdc, SYSTEMTIME* pt, int beat100)
{
	BITMAP bmp;
	RECT rcFill,  rcClock;
	
	TEXTMETRIC tm;
	int hf, y, w;
	char s[1024], *p, *sp;
	SIZE sz;
	int xclock, yclock, wclock, hclock, xsrc, ysrc, wsrc, hsrc;
	int xcenter;
	HRGN hRgn, hOldRgn;
	COLORREF textcol, textshadow;
	
	textcol = colfore;
	if(textcol & 0x80000000) textcol = GetSysColor(textcol & 0x00ffffff);
	textshadow = colShadow;
	if(textshadow & 0x80000000) textshadow = GetSysColor(textshadow & 0x00ffffff);
	
	if(!hdcClock) CreateClockDC(hwnd);
	
	if(!hdcClock || !hbmpClock) return;
	
	GetObject(hbmpClock, sizeof(BITMAP), (LPVOID)&bmp);
	rcFill.left = rcFill.top = 0;
	rcFill.right = bmp.bmWidth; rcFill.bottom = bmp.bmHeight;
	
	FillClock(hwnd, hdcClock, &rcFill, nBlink);
	
	MakeFormat(s, pt, beat100, format);
	
	GetClientRect(hwndClock, &rcClock);

	if(bFillTray && (fillbackcolor || bSkinTray))
	{
		POINT ptTray, ptClock;
		ptTray.x = ptTray.y = 0;
		ClientToScreen(GetParent(hwndClock), &ptTray);
		ptClock.x = ptClock.y = 0;
		ClientToScreen(hwndClock, &ptClock);
		xclock = ptClock.x - ptTray.x;
		yclock = ptClock.y - ptTray.y;
		wclock = rcClock.right;
		hclock = rcClock.bottom; //rcClock.bottom;
		
		hRgn = CreateRectRgn(xclock, 0,
			xclock + wclock, yclock + hclock);
		hOldRgn = SelectObject(hdcClock, hRgn);
	}
	else
	{
		xclock = 0;
		yclock = 0;
		wclock = rcClock.right;
		hclock = rcClock.bottom; //rcClock.bottom;
	}
	if(bGraph&&BackNetBand>0&&(xclock+wclock)>0&&(yclock+hclock)>0)
		DrawGraph(hwnd,hdcClock,xclock,yclock,wclock,hclock);
	
	GetTextMetrics(hdcClock, &tm);
	hf = tm.tmHeight - tm.tmInternalLeading;
	p = s;
	y = hf / 4 - tm.tmInternalLeading / 2 + yclock;
	if(nTextPos == 1)
		xcenter = xclock;
	else if(nTextPos == 2)
		xcenter = wclock + xclock - nShadowRange;
	else
		xcenter = wclock / 2 + xclock;
	w = 0;
	
	while(*p)
	{
		sp = p;
		while(*p && *p != 0x0d) p++;
		if(*p == 0x0d) { *p = 0; p += 2; }
		if(*p == 0 && sp == s)
		{
			y = (hclock - tm.tmHeight) / 2  - tm.tmInternalLeading / 4 + yclock;
		}
		if(GetTextExtentPoint32(hdcClock, sp, strlen(sp), &sz) == 0)
		{
			sz.cx = strlen(sp) * tm.tmAveCharWidth;
			sz.cy = tm.tmHeight;
		}
		if(w < sz.cx) w = sz.cx;
		
		if(bClockShadow)
		{
			SetTextColor(hdcClock, textshadow);
			TextOut(hdcClock, xcenter + nShadowRange, y + dvpos + nShadowRange, sp, strlen(sp));
			SetTextColor(hdcClock, textcol);
		}
		if(bClockBorder)
		{
			SetTextColor(hdcClock, textshadow);
			TextOut(hdcClock, xcenter - 1, y + dvpos + 1, sp, strlen(sp));
			TextOut(hdcClock, xcenter + 1, y + dvpos - 1, sp, strlen(sp));
			TextOut(hdcClock, xcenter + 1, y + dvpos + 1, sp, strlen(sp));
			TextOut(hdcClock, xcenter    , y + dvpos - 1, sp, strlen(sp));
			TextOut(hdcClock, xcenter + 1, y + dvpos    , sp, strlen(sp));
			TextOut(hdcClock, xcenter - 1, y + dvpos - 1, sp, strlen(sp));
			SetTextColor(hdcClock, textcol);
		}
		TextOut(hdcClock, xcenter, y + dvpos, sp, strlen(sp));

		y += hf; if(*p) y += 2 + dlineheight;
	}
	
	xsrc = 0; ysrc = 0; wsrc = rcFill.right; hsrc = rcFill.bottom;
	if(bFillTray && (fillbackcolor||bSkinTray))
	{
		xsrc = xclock; ysrc = yclock;
		wsrc = wclock; hsrc = hclock;
	}
	if(nBlink == 0 || (nBlink % 2))
		BitBlt(hdc, 0, dclkvpos, wsrc, hsrc - dclkvpos, hdcClock, xsrc, ysrc, SRCCOPY);
	else
		BitBlt(hdc, 0, dclkvpos, wsrc, hsrc - dclkvpos, hdcClock, xsrc, ysrc, NOTSRCCOPY);
	
	if(bFillTray && (fillbackcolor||bSkinTray))
	{
		SelectObject(hdcClock, hOldRgn);
		DeleteObject(hRgn);
	}
	
	w += tm.tmAveCharWidth * 2;
	w += dwidth;
	if(w > iClockWidth)
	{
		iClockWidth = w;
		PostMessage(GetParent(GetParent(hwndClock)), WM_SIZE,
			SIZE_RESTORED, 0);
		InvalidateRect(GetParent(GetParent(hwndClock)), NULL, TRUE);
	}
}

/*------------------------------------------------
  paint graph
--------------------------------------------------*/
void DrawGraph(HWND hwnd, HDC hdc, int xclock, int yclock, int wclock, int hclock)
{
	int i, x, y, d;
	double one_dots, one_dotr;
	if(GraphL>wclock||GraphT>hclock)return;
	xclock+=GraphL;
	yclock+=GraphT;
	wclock-=GraphL+GraphR;
	hclock-=GraphT+GraphB;
	if(wclock>0&&hclock>0)
	{
		HPEN penSR = CreatePen(PS_SOLID,1,ColSR);
		HPEN penR = CreatePen(PS_SOLID,1,ColRecv);
		HPEN penS = CreatePen(PS_SOLID,1,ColSend);
		HGDIOBJ oldPen=SelectObject(hdc,(HGDIOBJ)penSR);
			if (graphMode == 1)
			{
				one_dotr = (double)(BackNetBand  * 1024);
				one_dots = (double)(BackNetBand2 * 1024);
			}
			else if (graphMode == 2)
			{
				one_dotr = (double)100;
				one_dots = (double)100;
			}
		if ( bGraphTate )
		{
			one_dotr/=(double)(xclock+wclock);
			one_dots/=(double)(xclock+wclock);
			MoveToEx(hdc,(xclock+wclock)-1,yclock,NULL);
			for(y=yclock;y<(yclock+hclock);y++)
			{
				if (bReverseGraph)
				{
					i = y - yclock;
					d = -1;
				}
				else
				{
					i = (yclock+hclock)-y-1;
					d = 1;
				}
				if(i>0&&i<MAXGRAPHLOG)
				{
					if(GraphType==1)
					{
						MoveToEx(hdc,(xclock+wclock)-1,y,NULL);
						if(recvlog[i]>sendlog[i])
						{
							if(sendlog[i]/one_dots>0)
							{
								SelectObject(hdc,(HGDIOBJ)penSR);
								LineTo(hdc,max((xclock+wclock)-(int)(sendlog[i]/one_dots),0),y);
							}
							if((recvlog[i]/one_dotr)>(sendlog[i]/one_dots))
							{
								SelectObject(hdc,(HGDIOBJ)penR);
								LineTo(hdc,max((xclock+wclock)-(int)(recvlog[i]/one_dotr),0),y);
							}
						}
						else
						{
							if(recvlog[i]/one_dotr>0)
							{
								SelectObject(hdc,(HGDIOBJ)penSR);
								LineTo(hdc,max((xclock+wclock)-(int)(recvlog[i]/one_dotr),0),y);
							}
							if((recvlog[i]/one_dotr)<(sendlog[i]/one_dots))
							{
								SelectObject(hdc,(HGDIOBJ)penS);
								LineTo(hdc,max((xclock+wclock)-(int)(sendlog[i]/one_dots),0),y);
							}
						}
					}
					else if(GraphType==2)
					{
						if(i<MAXGRAPHLOG)
						{
							if(graphMode==1)
							{
								MoveToEx(hdc,max((xclock+wclock)-(int)(sendlog[i+1]/one_dots),0),y-d,NULL);
								SelectObject(hdc,(HGDIOBJ)penS);
								LineTo(hdc,max((xclock+wclock)-(int)(sendlog[i]/one_dots),0),y);
								MoveToEx(hdc,max((xclock+wclock)-(int)(recvlog[i+1]/one_dotr),0),y-d,NULL);
								SelectObject(hdc,(HGDIOBJ)penR);
								LineTo(hdc,max((xclock+wclock)-(int)(recvlog[i]/one_dotr),0),y);
							}
							else if(graphMode==2)
							{
								MoveToEx(hdc,max((xclock+wclock)-(int)(recvlog[i+1]/one_dotr),0),y-d,NULL);
								if(sendlog[i]==recvlog[i])
								{
									SelectObject(hdc,(HGDIOBJ)penSR);
								}
								else
								{
									SelectObject(hdc,(HGDIOBJ)penR);
								}
								LineTo(hdc,max((xclock+wclock)-(int)(recvlog[i]/one_dotr),0),y);
							}
						}
					}
				}
			}
		}
		else
		{
			one_dotr/=(double)(yclock+hclock);
			one_dots/=(double)(yclock+hclock);
			for(x=xclock;x<(xclock+wclock);x++)
			{
				if (bReverseGraph)
				{
					i = x - xclock;
					d = -1;
				}
				else
				{
					i = (xclock+wclock)-x-1;
					d = 1;
				}
				if(i>0&&i<MAXGRAPHLOG)
				{
					if(GraphType==1)
					{
						MoveToEx(hdc,x,(yclock+hclock)-1,NULL);
						if(recvlog[i]>sendlog[i])
						{
							if(sendlog[i]/one_dots>0)
							{
								SelectObject(hdc,(HGDIOBJ)penSR);
								LineTo(hdc,x,max((yclock+hclock)-(int)(sendlog[i]/one_dots),0));
							}
							if((recvlog[i]/one_dotr)>(sendlog[i]/one_dots))
							{
								SelectObject(hdc,(HGDIOBJ)penR);
								LineTo(hdc,x,max((yclock+hclock)-(int)(recvlog[i]/one_dotr),0));
							}
						}
						else
						{
							if(recvlog[i]/one_dotr>0)
							{
								SelectObject(hdc,(HGDIOBJ)penSR);
								LineTo(hdc,x,max((yclock+hclock)-(int)(recvlog[i]/one_dotr),0));
							}
							if((recvlog[i]/one_dotr)<(sendlog[i]/one_dots))
							{
								SelectObject(hdc,(HGDIOBJ)penS);
								LineTo(hdc,x,max((yclock+hclock)-(int)(sendlog[i]/one_dots),0));
							}
						}
					}
					else if(GraphType==2)
					{
						if(i<MAXGRAPHLOG)
						{
							if(graphMode==1)
							{
								MoveToEx(hdc,x-d,max((yclock+hclock)-(int)(sendlog[i+1]/one_dots),0),NULL);
								SelectObject(hdc,(HGDIOBJ)penS);
								LineTo(hdc,x,max((yclock+hclock)-(int)(sendlog[i]/one_dots),0));
								MoveToEx(hdc,x-d,max((yclock+hclock)-(int)(recvlog[i+1]/one_dotr),0),NULL);
								SelectObject(hdc,(HGDIOBJ)penR);
								LineTo(hdc,x,max((yclock+hclock)-(int)(recvlog[i]/one_dotr),0));
							}
							else if(graphMode==2)
							{
								MoveToEx(hdc,x-d,max((yclock+hclock)-(int)(recvlog[i+1]/one_dotr),0),NULL);
								if(sendlog[i]==recvlog[i])
								{
									SelectObject(hdc,(HGDIOBJ)penSR);
								}
								else
								{
									SelectObject(hdc,(HGDIOBJ)penR);
								}
								LineTo(hdc,x,max((yclock+hclock)-(int)(recvlog[i]/one_dotr),0));
							}
						}
					}
				}
			}
		}
		SelectObject(hdc,oldPen);
		DeleteObject(penSR);
		DeleteObject(penR);
		DeleteObject(penS);
	}
}

void getGraphVal()
{
	int i;
	
	if (graphMode == 1)
	{
		double allrecv=0,allsend=0;
		Net_getRecvSend(&allrecv,&allsend);
		if(recvlog[0]==0)
		{
			recvlog[0]=allrecv;
			sendlog[0]=allsend;
		}
		else
		{
			recvlog[0]=(allrecv-recvlog[0])/graphInterval;
			sendlog[0]=(allsend-sendlog[0])/graphInterval;
			for(i=MAXGRAPHLOG-1;i>=0;i--)
			{
				sendlog[i+1]=sendlog[i];
				recvlog[i+1]=recvlog[i];
			}
			recvlog[0]=allrecv;
			sendlog[0]=allsend;
		}
	}
	else if (graphMode == 2)
	{
		int cpu_u;
		for(i=MAXGRAPHLOG-1;i>=0;i--)
		{
			sendlog[i+1]=sendlog[i];
			recvlog[i+1]=recvlog[i];
		}
		cpu_u = bGetSysRes ? iCPUUsage : CpuMoni_get();
		if (cpu_u >= cpuHigh)
		{
			recvlog[0]=(double)cpu_u;
			sendlog[0]=cpuHigh;
		}
		else
		{
			recvlog[0]=(double)cpu_u;
			sendlog[0]=(double)cpu_u;
		}
	}
	bGraphRedraw = TRUE;
}

/*------------------------------------------------
  paint background of clock
--------------------------------------------------*/
void FillClock(HWND hwnd, HDC hdc, RECT *prc, int nblink)
{
	HBRUSH hbr;
	COLORREF col;
	HDC hdcTemp;
	BITMAP bmp;
	
	col = colfore;
	if(col & 0x80000000) col = GetSysColor(col & 0x00ffffff);
	SetTextColor(hdc, col);

	if(bSkinTray)
	{
		HGDIOBJ hOldBmp;
		hdcTemp = CreateCompatibleDC(hdc);
		hOldBmp = SelectObject(hdcTemp, hbmpClockSkin);
		GetObject(hbmpClockSkin, sizeof(BITMAP), (LPVOID)&bmp);
		//-----draw corners-----
		//Top Left
		StretchBlt(hdc, 0, 0, tEdgeLeft, tEdgeTop, hdcTemp, 0, 
			0, tEdgeLeft, tEdgeTop, SRCCOPY);
		//Top Right
		StretchBlt(hdc, prc->right - tEdgeRight, 0, tEdgeRight, tEdgeTop, hdcTemp, 
			bmp.bmWidth - tEdgeRight, 0, tEdgeRight, tEdgeTop, SRCCOPY);
		//Bottom Left
		StretchBlt(hdc, 0, prc->bottom - tEdgeBottom, tEdgeLeft, tEdgeBottom, hdcTemp,
			0, bmp.bmHeight - tEdgeBottom, tEdgeLeft, tEdgeBottom, SRCCOPY);
		//Bottom Right
		StretchBlt(hdc, prc->right - tEdgeRight, prc->bottom - tEdgeBottom, tEdgeRight, 
			tEdgeBottom, hdcTemp, bmp.bmWidth - tEdgeRight, bmp.bmHeight - tEdgeBottom, 
			tEdgeRight, tEdgeBottom, SRCCOPY);
		
		//-----draw edges-----
		//Top
		StretchBlt(hdc, tEdgeLeft, 0, (prc->right - tEdgeRight) - tEdgeLeft, tEdgeTop, 
			hdcTemp, tEdgeLeft, 0, (bmp.bmWidth - tEdgeRight) - tEdgeLeft, tEdgeTop, SRCCOPY);
		//Left
		StretchBlt(hdc, 0, tEdgeTop, tEdgeLeft, (prc->bottom - tEdgeBottom) - tEdgeTop, 
			hdcTemp, 0, tEdgeTop, tEdgeLeft, (bmp.bmHeight - tEdgeBottom) - tEdgeTop, SRCCOPY);
		//Bottom
		StretchBlt(hdc, tEdgeLeft, prc->bottom - tEdgeBottom, 
			(prc->right - tEdgeRight) - tEdgeLeft, tEdgeBottom, hdcTemp, tEdgeLeft, 
			bmp.bmHeight - tEdgeBottom, (bmp.bmWidth - tEdgeRight) - tEdgeLeft, 
			tEdgeBottom, SRCCOPY);
		//Right
		StretchBlt(hdc, prc->right - tEdgeRight, tEdgeTop, tEdgeRight, 
			(prc->bottom - tEdgeBottom) - tEdgeTop, hdcTemp, bmp.bmWidth - tEdgeRight, 
			tEdgeTop, tEdgeRight, (bmp.bmHeight - tEdgeBottom) - tEdgeTop, SRCCOPY);


		StretchBlt(hdc, tEdgeLeft, tEdgeTop, (prc->right - tEdgeRight) - tEdgeLeft,
			(prc->bottom - tEdgeBottom) - tEdgeTop, hdcTemp, tEdgeLeft, tEdgeTop, 
			(bmp.bmWidth - tEdgeRight) - tEdgeLeft, (bmp.bmHeight - tEdgeBottom) - tEdgeTop, 
			SRCCOPY);

		SelectObject(hdcTemp, hOldBmp);
		DeleteDC(hdcTemp);
	}else if (!fillbackcolor && !bSkinTray)
	{
		HGDIOBJ hOldBmp;
		HDC hdcTemp, hdcBmp;
		RECT rcTray, rcClock;
		HBITMAP hbmp;

		GetWindowRect(GetParent(hwnd), &rcTray);
		GetWindowRect(hwnd, &rcClock);

		hdcTemp = GetDC(NULL);
		hdcBmp = CreateCompatibleDC(hdcTemp);
		hbmp = CreateCompatibleBitmap(hdcTemp, rcTray.right-rcTray.left, rcTray.bottom-rcTray.top);
		hOldBmp = SelectObject(hdcBmp, hbmp);
		SendMessage(GetParent(hwnd), WM_PRINTCLIENT, (WPARAM)hdcBmp, (LPARAM)PRF_CLIENT);

		BitBlt(hdc, 0, 0, prc->right, prc->bottom, hdcBmp, rcClock.left-rcTray.left, rcClock.top-rcTray.top, SRCCOPY);

		SelectObject(hdcTemp, hOldBmp);
		DeleteDC(hdcBmp);
		DeleteObject(hbmp);
		ReleaseDC(NULL, hdcTemp);
	}
	else if(colback == colback2 || !bWin98)
	{
		col = colback;
		if(col & 0x80000000) col = GetSysColor(col & 0x00ffffff);
		hbr = CreateSolidBrush(col);
		FillRect(hdc, prc, hbr);
		DeleteObject(hbr);
	}
	else
	{
		COLORREF col2;
		
		col = colback;
		if(col & 0x80000000) col = GetSysColor(col & 0x00ffffff);
		col2 = colback2;
		if(col2 & 0x80000000) col2 = GetSysColor(col2 & 0x00ffffff);
		
		GradientFillClock(hdc, prc, col, col2, grad);
	}
}

/*------------------------------------------------
@vɕKvȃTCYԂ
@߂lFWORD @WORD 
--------------------------------------------------*/
LRESULT OnCalcRect(HWND hwnd)
{
	SYSTEMTIME t;
	int beat100;
	LRESULT w, h;
	HDC hdc;
	HGDIOBJ hOldFont;
	TEXTMETRIC tm;
	char s[1024], *p, *sp;
	SIZE sz;
	int hf;
	
	if(!(GetWindowLong(hwnd, GWL_STYLE)&WS_VISIBLE)) return 0;
	
	hdc = GetDC(hwnd);
	
	if(hFon) hOldFont = SelectObject(hdc, hFon);
	GetTextMetrics(hdc, &tm);
	
	GetDisplayTime(&t, nDispBeat?(&beat100):NULL);
	MakeFormat(s, &t, beat100, format);
	
	p = s; w = 0; h = 0;
	hf = tm.tmHeight - tm.tmInternalLeading;
	while(*p)
	{
		sp = p;
		while(*p && *p != 0x0d) p++;
		if(*p == 0x0d) { *p = 0; p += 2; }
		if(GetTextExtentPoint32(hdc, sp, strlen(sp), &sz) == 0)
			sz.cx = strlen(sp) * tm.tmAveCharWidth;
		if(w < sz.cx) w = sz.cx;
		h += hf; if(*p) h += 2 + dlineheight;
	}
	w += tm.tmAveCharWidth * 2;
	w += dwidth;
	if(w > iClockWidth)iClockWidth = w;
	h += hf / 2 + dheight + dclkvpos;
	if(bClockShadow)
	{
		h += nShadowRange; w += nShadowRange;
	}
	if(h < 4) h = 4;
	
	if(hFon) SelectObject(hdc, hOldFont);
	ReleaseDC(hwnd, hdc);
	
	return (h << 16) + w;
}

//	<( ''[)>
//	2002/11/26 - H.N. Neri-uma added.
//	2002/11/27 - 635 modified.
//-------------------------------------------------
//	GetToolTipText
//		Tooltip̃eLXgAWXgł͂ȂAeLXgt@Cǂݍ݂܂B
//	F	[char * pszText]	ǂݍ񂾕i[ϐւ̃|C^
//	߂lF0		G[BeLXgt@C݂ȂBt@C݂͑A󂾂BȂ
//			0ȊO	
//-------------------------------------------------
static BOOL GetToolTipText(PSTR pszText)
{
	HANDLE	hFile;
	char	szFilePath[MAX_PATH];	//	eLXgt@C̃pX
	DWORD	dwReadSize;
	DWORD	dwFileSize;

	if(!pszText)
	{
		//	li[AhX݂Ȃ̂ŁAFALSEԂďI
		return FALSE;
	}
	
	//	eLXgt@C̃pX쐬
	//GetModuleFileName(hmod, szFilePath, sizeof(szFilePath));
	//del_title(szFilePath);
	//add_title(szFilePath, TIPTEXTFILENAME);
	
	//635@p5 t@C擾ăc[`bvNAB
	strcpy(szFilePath,pszText);
	strcpy(pszText, "");
	
	//	t@Cǂݍ
	hFile = CreateFile(szFilePath,
					   GENERIC_READ,
					   FILE_SHARE_READ,
					   NULL,
					   OPEN_EXISTING,
					   FILE_ATTRIBUTE_NORMAL,
					   NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		//	t@C݂Ȃ̂ŁAFALSEԂďI
		return FALSE;
	}

	dwFileSize = GetFileSize(hFile, NULL);
	
	if ( dwFileSize > (DWORD)LEN_TOOLTIP)
		dwFileSize = (DWORD)(LEN_TOOLTIP-1);
	
	//	t@Cǂݍ
	ReadFile(hFile, pszText, dwFileSize, &dwReadSize, NULL);
	//	t@CN[Y
	CloseHandle(hFile);

	if(strcmp(pszText, "") == 0)
	{
		//	擾ɎsBWXg擾֑点邽߂FALSEԂďI
		return FALSE;
	}

	//	̖ɁAINULL Stringti^^;
	pszText[dwFileSize] = '\0';

	//	̂TRUEԂ
	return TRUE;
}
//	</( ''[)>

/*------------------------------------------------
@c[`bv̕\e擾
--------------------------------------------------*/
static void UpdateTooltipTitle(void)
{
	InterlockedIncrement(&lLockTipTextUpdate);
	if (bToolTipHasTitle || *titleTooltip)
	{
		bToolTipHasTitle = SendMessage(hwndTip, TTM_SETTITLE,GetMyRegLongEx("", "TipIcon", 0, gConfigNo),(LPARAM)(LPCTSTR)(char*)titleTooltip);
		if (!*titleTooltip) bToolTipHasTitle = FALSE;
	}
	InterlockedDecrement(&lLockTipTextUpdate);
}

/*------------------------------------------------
@c[`bv̕\e擾
--------------------------------------------------*/
void UpdateTooltipText(void)
{
	const static char * const aszRegEntry[3] =
	{
		"Tooltip",
		"Tooltip2",
		"Tooltip3",
	};
	SYSTEMTIME t;
	int beat100;
	char fmt[LEN_TOOLTIP], s[LEN_TOOLTIP], tiptitle[300], tipt[300], ini_key[10];
	DWORD dw;
	RECT rcClock;
	int clLen, mPos;
	BOOL bTip2, bTip3, bTipTate;
	bTooltipUpdated = TRUE;
	bTip2 = GetMyRegLongEx("Tooltip", "Tip2Use", FALSE, gConfigNo);
	if (bTip2)
	{
		bTip3    = GetMyRegLongEx("Tooltip", "Tip3Use", FALSE, gConfigNo);
		bTipTate = GetMyRegLongEx("Tooltip", "TipTateFlg", FALSE, gConfigNo);
		
		GetWindowRect(hwndClock, &rcClock);
		dw = GetMessagePos();
		if (bTipTate)
		{
			clLen = rcClock.bottom - rcClock.top;
			mPos  = GET_Y_LPARAM(dw) - rcClock.top;
		}
		else
		{
			clLen = rcClock.right - rcClock.left;
			mPos  = GET_X_LPARAM(dw) - rcClock.left;
		}
		if (bTip3)
		{
			if ( mPos > (2*clLen/3) )
				iTipSelected = 2;
			if ( mPos <= (2*clLen/3) && mPos >= (clLen/3) )
				iTipSelected = 1;
			if ( mPos < (clLen/3) )
				iTipSelected = 0;
		}
		else
		{
			if ( mPos > (clLen/2) )
				iTipSelected = 1;
			if ( mPos <= (clLen/2) )
				iTipSelected = 0;
		}
	}
	else
	{
		iTipSelected = 0;
	}
	strcpy(ini_key, aszRegEntry[iTipSelected]);
	
//	<( ''[)> & 635@p5
	GetMyRegStrEx("Tooltip", ini_key, fmt, sizeof(fmt), "", gConfigNo);
	if(fmt[0] == 'f' && fmt[1] == 'i' && fmt[2] == 'l' && fmt[3] == 'e' && fmt[4] == ':')
	{
		memmove( fmt, fmt + 5, (size_t)((strchr(fmt,'\0')-1)-fmt));
		if(!GetToolTipText(fmt)){
			strcpy(fmt, "\"t@C擾s\"\\n\\nLDATE");
		}
	}
	if(fmt[0] == 0)
	{
		strcpy(fmt, "\"TClock\" LDATE");
	}
//	</( ''[)>
	
	GetDisplayTime(&t, &beat100);
	MakeFormat(s, &t, beat100, fmt);
	if (!lLockTipTextUpdate) strcpy(formatTooltip, s);

	//635@p5
	GetMyRegStrEx("", "TipTitle", tiptitle, 300, "", gConfigNo);
	if(tiptitle[0] != 0)
	{
		MakeFormat(tipt, &t, beat100, tiptitle);
		if (!lLockTipTextUpdate) strcpy(titleTooltip, tipt);
	}
	else
	{
		if (!lLockTipTextUpdate) titleTooltip[0] = 0;
	}
	//end
}
/*------------------------------------------------
@c[`bv̕\XV
--------------------------------------------------*/
void OnTimerTooltip(HWND hwnd)
{
	TOOLINFO ti;
	if (!bTooltipShow) return;
	if (!bTipUpdateEnable[iTipSelected]) return;

	UpdateTooltipText();
	UpdateTooltipTitle();

	ti.cbSize = sizeof(TOOLINFO);
	ti.hwnd = hwnd;
	ti.uId = 1;
	SendMessage(hwndTip, TTM_GETTOOLINFO, 0, (LPARAM)(LPTOOLINFO)&ti);
	ti.uFlags = 0;
	ti.hinst = NULL;
	ti.lpszText = LPSTR_TEXTCALLBACK;
	SendMessage(hwndTip, TTM_UPDATETIPTEXT, 0, (LPARAM)(LPTOOLINFO)&ti);
}

/*------------------------------------------------
  copy date/time text to clipboard
--------------------------------------------------*/
void OnCopy(HWND hwnd, LPARAM lParam)
{
	SYSTEMTIME t;
	int beat100;
	char entry[20], fmt[256], s[1024], *pbuf;
	HGLOBAL hg;
	BOOL br, bb, bm, bmb, bpm, bn, bhd, bcc, bvl;
	DWORD dwInfoFormat;
	
	GetDisplayTime(&t, &beat100);
	wsprintf(entry, "%d%dClip", (int)LOWORD(lParam), (int)HIWORD(lParam));
	GetMyRegStrEx("Mouse", entry, fmt, 256, "", gConfigNo);
	if(fmt[0] == 0) strcpy(fmt, format);
	
	dwInfoFormat = FindFormat(fmt);
	br = (dwInfoFormat&FORMAT_SYSINFO)? TRUE:FALSE;
	bb = (dwInfoFormat&FORMAT_BATTERY)? TRUE:FALSE;
	bm = (dwInfoFormat&FORMAT_MEMORY) ? TRUE:FALSE;
	bmb = (dwInfoFormat&FORMAT_MOTHERBRD) ? TRUE:FALSE;
	bpm = (dwInfoFormat&FORMAT_PERMON) ? TRUE:FALSE;
	bn = (dwInfoFormat&FORMAT_NET) ? TRUE:FALSE;
	bhd = (dwInfoFormat&FORMAT_HDD) ? TRUE:FALSE;
	bcc = (dwInfoFormat&FORMAT_CPU) ? TRUE:FALSE;
	bvl = (dwInfoFormat&FORMAT_VOL) ? TRUE:FALSE;
	if(br || bb || bm || bmb || bpm || bn || bhd || bcc || bvl)
		UpdateSysRes(hwnd, br, bb, bm, bmb, bpm, bn, bhd, bcc, bvl);
	
	MakeFormat(s, &t, beat100, fmt);
	
	if(!OpenClipboard(hwnd)) return;
	EmptyClipboard();
	hg = GlobalAlloc(GMEM_DDESHARE, strlen(s) + 1);
	pbuf = (char*)GlobalLock(hg);
	strcpy(pbuf, s);
	GlobalUnlock(hg);
	SetClipboardData(CF_TEXT, hg);
	CloseClipboard();
}

void UpdateSysRes(HWND hwnd, BOOL bsysres, BOOL bbattery, BOOL bmem, BOOL bmb, BOOL bpermon, BOOL bnet, BOOL bhdd, BOOL bcpuc, BOOL bvol)
{
	int i;
	
	if(bsysres)
	{
//		char s[10];
		
		if(bWin95)
		{
			for(i = 0; i < 3; i++)
				iFreeRes[i] = GetFreeSystemResources((WORD)i);
		}
		iCPUUsage = CpuMoni_get(); // cpu.c
		
//		wsprintf(s, "%d", iCPUUsage);
//		WriteDebug(s);
	}
	if((bWin95 || bWin2000) && bbattery)
	{
		iBatteryLife = GetBatteryLifePercent();
	}
	if((bWin98 || bWin2000) && bcpuc)
	{
		iCpuClock = GetCpuClock();
	}
	if(bmem)
	{
		msMemory.dwLength = sizeof(msMemory);
		GlobalMemoryStatusEx(&msMemory);
	}
	if(bmb)
	{
		MBMSharedDataUpdate();
	}
	if(bvol)
	{
		BOOL muteflg;
		GetMasterVolume(&iVolume);
		GetMasterMute(&muteflg);
		if (muteflg)
			iVolume = 0;
	}
	if(bpermon)
	{
//		PerMoni_get();
	}
	if(bnet)
	{
		Net_get();
	}
	if(bhdd)
	{
		Hdd_get();
	}
}

int iHourTransition = -1, iMinuteTransition = -1;

/*------------------------------------------------
  initialize time-zone information
--------------------------------------------------*/
void InitDaylightTimeTransition(void)
{
	SYSTEMTIME lt, *plt;
	TIME_ZONE_INFORMATION tzi;
	DWORD dw;
	BOOL b;
	
	iHourTransition = iMinuteTransition = -1;
	
	GetLocalTime(&lt);
	
	b = FALSE;
	memset(&tzi, 0, sizeof(tzi));
	dw = GetTimeZoneInformation(&tzi);
	if(dw == TIME_ZONE_ID_STANDARD
	  && tzi.DaylightDate.wMonth == lt.wMonth
	  && tzi.DaylightDate.wDayOfWeek == lt.wDayOfWeek)
	{
		b = TRUE; plt = &(tzi.DaylightDate);
	}
	if(dw == TIME_ZONE_ID_DAYLIGHT
	  && tzi.StandardDate.wMonth == lt.wMonth
	  && tzi.StandardDate.wDayOfWeek == lt.wDayOfWeek)
	{
		b = TRUE; plt = &(tzi.StandardDate);
	}
	
	if(b && plt->wDay < 5)
	{
		if(((lt.wDay - 1) / 7 + 1) == plt->wDay)
		{
			iHourTransition = plt->wHour;
			iMinuteTransition = plt->wMinute;
		}
	}
	else if(b && plt->wDay == 5)
	{
		FILETIME ft;
		SystemTimeToFileTime(&lt, &ft);
		*(DWORDLONG*)&ft += 6048000000000i64;
		FileTimeToSystemTime(&ft, &lt);
		if(lt.wDay < 8)
		{
			iHourTransition = plt->wHour;
			iMinuteTransition = plt->wMinute;
		}
	}
}

BOOL CheckDaylightTimeTransition(SYSTEMTIME *plt)
{
	if((int)plt->wHour == iHourTransition &&
	   (int)plt->wMinute >= iMinuteTransition)
	{
		iHourTransition = iMinuteTransition = -1;
		return TRUE;
	}
	else return FALSE;
}

/*---------------------------------------
	^XNgCtɎvL
---------------------------------------*/
void FitClock()
{
	static LONG lLockFitClock = -1;
	int x, y, cx, cy;
	RECT rcTray, rcClock;
	if (InterlockedIncrement(&lLockFitClock) == 0)
	{
		GetClientRect(hwndClock, &rcClock);
		GetClientRect(GetParent(hwndClock),&rcTray);

		if (((rcTray.right - rcTray.left) - (rcClock.right - rcClock.left)) > ((rcTray.bottom - rcTray.top) - (rcClock.bottom - rcClock.top)))
			{
				/* fit right-side */
				x = rcTray.left + (rcTray.right - rcTray.left) - (rcClock.right - rcClock.left);
				cx = rcClock.right - rcClock.left;
				y = rcTray.top;
				cy = rcTray.bottom - rcTray.top;
				SetWindowPos(hwndClock,0, x, y, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE | SWP_NOSENDCHANGING | SWP_NOREDRAW);
			}
		else
			{
				/* fit up-side */
				x = rcTray.left;
				y = rcTray.top;
				cx = rcTray.right - rcTray.left;
				cy = rcClock.bottom - rcTray.top;
				SetWindowPos(hwndClock,0, x, y, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE | SWP_NOSENDCHANGING | SWP_NOREDRAW);
			}
	}
	InterlockedDecrement(&lLockFitClock);
}

/*----------------------------------------------
     [U[`炤B
----------------------------------------------*/
void OnCopyData(HWND hwnd, COPYDATASTRUCT* pCopyDataStruct)
{
	if (lstrlen((LPCTSTR)pCopyDataStruct->lpData) > 100 )
		return;
	switch(pCopyDataStruct->dwData)
	{
		case 0:
			lstrcpy(usrstr[0].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 1:
			lstrcpy(usrstr[1].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 2:
			lstrcpy(usrstr[2].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 3:
			lstrcpy(usrstr[3].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 4:
			lstrcpy(usrstr[4].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 5:
			lstrcpy(usrstr[5].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 6:
			lstrcpy(usrstr[6].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 7:
			lstrcpy(usrstr[7].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 8:
			lstrcpy(usrstr[8].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
		case 9:
			lstrcpy(usrstr[9].u_str,(LPCTSTR)pCopyDataStruct->lpData);
			break;
	}
}
