
#include "tclock.h"

static int MaxCol = 16;
extern int confNo;

/*------------------------------------------------
@uFvR{{bNX̏
--------------------------------------------------*/
void InitComboColor(HWND hDlg, int numcol, COMBOCOLOR *pCombocolor, int maxcol, BOOL ex_flg)
{
	COLORREF col;
	int i, j;
	WORD id;
	//WindowsftHg16F+{^̐F
	static COLORREF rgb[20] = {
		RGB(0,0,0),
		RGB(128,0,0),
		RGB(0,128,0),
		RGB(128,128,0),
		RGB(0,0,128),
		RGB(128,0,128),
		RGB(0,128,128),
		RGB(192,192,192),
		RGB(128,128,128),
		RGB(255,0,0),
		RGB(0,255,0),
		RGB(255,255,0),
		RGB(0,0,255),
		RGB(255,0,255),
		RGB(0,255,255),
		RGB(255,255,255),
		0x80000000|COLOR_3DFACE,
		0x80000000|COLOR_3DSHADOW,
		0x80000000|COLOR_3DHILIGHT,
		0x80000000|COLOR_BTNTEXT
	};

	MaxCol = maxcol;

	for(i = 0; i < numcol; i++)
	{
		id = pCombocolor[i].id;

		// WinXP̃oOւ̑Ώ(VisualStylegp0ǉłȂ)
		CBSetItemData(hDlg, id, CBAddString(hDlg, id, -1), rgb[0]);
		for(j = 1; j < maxcol; j++) //ȊO̎c̊{16F+{^̐F
			CBAddString(hDlg, id, rgb[j]);
		
		//R{{bNX̐FI
		if (ex_flg)
		{
			if (pCombocolor[i].defcol == 0xFFFFFFFF)
				col = GetMyRegLongEx("", pCombocolor[i].colname, col,confNo);
			else
				col = GetMyRegLongEx("", pCombocolor[i].colname, pCombocolor[i].defcol, confNo);
		}
		else
		{
			if (pCombocolor[i].defcol == 0xFFFFFFFF)
				col = GetMyRegLong("", pCombocolor[i].colname, col);
			else
				col = GetMyRegLong("", pCombocolor[i].colname, pCombocolor[i].defcol);
		}
		
		for(j = 0; j < maxcol; j++)
		{
			if(col == (COLORREF)CBGetItemData(hDlg, id, j))
				break;
		}
		if(j == maxcol) //20FɂȂƂ
			CBAddString(hDlg, id, col);
		CBSetCurSel(hDlg, id, j);
		
		//Xgڂ̕\w
		AdjustDlgConboBoxDropDown(hDlg, id, 10);
	}
}

/*------------------------------------------------
@uFvR{{bNX̍̐ݒ
--------------------------------------------------*/
void OnMeasureItemColorCombo(LPARAM lParam)
{
	LPMEASUREITEMSTRUCT pmis;
	
	pmis = (LPMEASUREITEMSTRUCT)lParam;
	pmis->itemHeight = 7 * HIWORD(GetDialogBaseUnits()) / 8;
}

/*------------------------------------------------
@uFvR{{bNX̃I[i[h[
--------------------------------------------------*/
void OnDrawItemColorCombo(LPARAM lParam, int maxcol)
{
	LPDRAWITEMSTRUCT pdis;
	HBRUSH hbr;
	COLORREF col;
	TEXTMETRIC tm;
	int y;

	pdis = (LPDRAWITEMSTRUCT)lParam;
	
	if(IsWindowEnabled(pdis->hwndItem))
	{
		col = pdis->itemData;
		if(col & 0x80000000) col = GetSysColor(col & 0x00ffffff);
	}
	else col = GetSysColor(COLOR_3DFACE);
	
	switch(pdis->itemAction)
	{
		case ODA_DRAWENTIRE:
		case ODA_SELECT:
		{
			hbr = CreateSolidBrush(col);
			FillRect(pdis->hDC, &pdis->rcItem, hbr);
			DeleteObject(hbr);

			// print color names
			if(maxcol > 16 && 16 <= pdis->itemID && pdis->itemID <= 19)
			{
				char s[80];
				strcpy(s, MyString(IDS_BTNFACE + pdis->itemID - 16));
				SetBkMode(pdis->hDC, TRANSPARENT);
				GetTextMetrics(pdis->hDC, &tm);
				if((GetRValue(col)+GetGValue(col)+GetBValue(col)) <= 384)
					SetTextColor(pdis->hDC, RGB(255,255,255));
				else
					SetTextColor(pdis->hDC, RGB(0,0,0));
				y = (pdis->rcItem.bottom - pdis->rcItem.top - tm.tmHeight)/2;
				TextOut(pdis->hDC, pdis->rcItem.left + 4, pdis->rcItem.top + y,
					s, strlen(s));
			}
			if(!(pdis->itemState & ODS_FOCUS)) break;
		}
		case ODA_FOCUS:
		{
			hbr = CreateSolidBrush((pdis->itemState & ODS_FOCUS)? 0 : col);
			FrameRect(pdis->hDC, &pdis->rcItem, hbr);
			DeleteObject(hbr);
			break;
		}
	}
}

/*------------------------------------------------
@F̑I u...v{^
--------------------------------------------------*/
void OnChooseColor(HWND hDlg, WORD id, int maxcol)
{
	CHOOSECOLOR cc;
	COLORREF col, colarray[16];
	WORD idCombo;
	int i;
	
	idCombo = id - 1;
	
	//ŏɑI΂ĂF
	col = CBGetItemData(hDlg, idCombo, CBGetCurSel(hDlg, idCombo));
	if(col & 0x80000000) col = GetSysColor(col & 0x00ffffff);
	
	for(i = 0; i < 16; i++) colarray[i] = RGB(255,255,255);
	
	memset(&cc, 0, sizeof(CHOOSECOLOR));
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = hDlg;
	cc.hInstance = (HWND)g_hInst;
	cc.rgbResult = col;
	cc.lpCustColors = colarray;
	cc.Flags = CC_FULLOPEN | CC_RGBINIT;
	
	if(!ChooseColor(&cc)) return;
	
	for(i = 0; i < 16; i++)
	{
		if(cc.rgbResult == (COLORREF)CBGetItemData(hDlg, idCombo, i))
			break;
	}
	if(i == 16) //{16Fł͂ȂƂ
	{
		if(CBGetCount(hDlg, idCombo) == maxcol)
			CBAddString(hDlg, idCombo, cc.rgbResult);
		else
			CBSetItemData(hDlg, idCombo, maxcol, cc.rgbResult);
		i = maxcol;
	}
	CBSetCurSel(hDlg, idCombo, i);
	
	PostMessage(hDlg, WM_NEXTDLGCTL, 1, FALSE);
}


